/*
 *  This file is part of the VBMP3 package.
 *
 *  VBMP3, MP3 Operating Library
 *  originally Copyright (C) 1999-2000 Daisuke Karikomi
 *
 *  Portions Copyright (C) 2002 Kobarin
 */

#ifndef __MP3INPUT_H__
#define __MP3INPUT_H__

#include <windows.h>
#include <process.h>	//_beginthreadex, _endthreadex
#include <string.h>		//memmove
#include <stdio.h>		//fgets
#include "mp3dec.h"
#include "VBMP3.h"

#pragma pack(1)
struct ID3Tagv1 {
	BYTE	tag[3];			//^O
	BYTE	trackName[30];	//gbN
	BYTE	artistName[30];	//A[eBXg
	BYTE	albumName[30];	//Ao
	BYTE	year[4];		//[XN
	BYTE	comment[30];	//Rg
	BYTE	genre;			//Wԍ
};//128oCg
#pragma pack()

#pragma pack(1)
struct ID3Tagv2 {
	BYTE	id3[3];			//^O
	BYTE	version;		//o[W
	BYTE	revision;		//rW
	BYTE	flags;			//tO
	BYTE	size[4];		//TCY
};
#pragma pack()

#pragma pack(1)
struct ID3Tagv23 {
	BYTE	frameid[3];		//t[ID
	BYTE	size[4];		//TCY
	BYTE	flags[2];		//tO
};
#pragma pack()

#pragma pack(1)
struct RiffChunk {
	BYTE	chunkID[4];		//'RIFF'
	DWORD	chunkSize;		//`NTCY
	BYTE	formatType[4];	//'WAVE','RMP3'
};

struct CommonChunk {
	BYTE	chunkID[4];		//`NID
	DWORD	chunkSize;		//`NTCY
};

struct RMPInfo {
	BYTE	infoID[4];		//SItB[h^O
	DWORD	length;			//TCY
	BYTE	data[1];		//f[^
};
#pragma pack()

struct LYRICS_WORK
{
	long	sec;					//~b
	int		lineno;					//sԍ 0`
	int		point;					//sʒu 1`
	BOOL	tagFlag;				//^OL
	int		textSize;				//eLXgTCY[byte]
	char	lyrics[INFO_NAME_SIZE];	//̎
	BOOL	atTagFlag;				//^OL
};

/* 萔 */
#define ALLOW_DATA_SIZE		268435455			//őf[^(ӂ΍)
#define VBMP3_VER	161							//VBMP3 Version
#define DEFAULT_BUFFER_SIZE	4096			//WAVEĐ̃obt@TCY
//#define DEFAULT_BUFFER_SIZE	44100

/* Đt@C֘A */
extern HANDLE		m_hWaveFile;				//WAVEt@C
extern HANDLE		m_hFile;					//Ώۂ̃t@C
extern char			m_openFileName[260];		//Ώۃt@C
extern wchar_t		m_openFileNameW[32769];		//Ώۃt@C
extern DWORD		dataSize;					//MPEG Audiof[^TCY
extern int			fileSize;					//MPEG t@CTCY
extern MPEG_DECODE_INFO m_decInfo;				//MPEGwb_
extern int			m_playSec;					//toߎ
extern int			m_playSecCur;				//toߎ(o͗p)
extern int			m_totalSec;					//t
extern long			m_totalMs;					//t(ms)
extern int			m_winampTotalSec;			//winampt
extern long			m_winampTotalMs;			//winampt(ms)
extern double		m_playMs;					//t̎ԁi~bj
extern int			m_playFrames;				//tt[
extern int			m_playSamples;				//tTv
extern TAG_INFO		tagInfo;					//^O
extern LIST_INFO	listInfo;					//Xg
extern int			m_FileType;					//َ̧
extern BOOL			m_openFileVBR;				//True = VBR` False = ̑

/* VBMP3 ֘A */
extern MPEG_DECODE_OPTION   decodeOption;		//fR[hGWIvV
extern int			m_lvol;						//{|
extern int			m_rvol;						//E{|
extern int			m_olvol;					//o̓{|
extern int			m_orvol;					//Eo̓{[
extern BOOL			m_fadeOutFlag;				//tF[hAEgݒ
extern int			m_inputBlock;				//̓t[
extern int			m_outputBlock_in;			//o̓t[
extern int			m_outputBlock_in_tmp;		//o̓t[(ꎞۑ)
extern int			m_outputBlock_in_wav;		//o̓t[(sb`ύX)
extern int			m_inputSleep;				//͒̃X[v(~b)
extern int			decFlag;					//fR[htO 0:Đ 1:Waveo 2:ĐȂWAVEo
extern int			m_platForm;					//1:WinNT 0:̑
extern BOOL			m_timeFlag;					//TRUE:tԂԉz؂̂

//Đxp
extern double		m_playSpeed;				//Đx
extern int			m_reduction;				//_ETvO
extern int			m_bitRate;					//Đ[g

/* t֘A */
extern HANDLE		m_hThread;					//fR[hpXbh
extern int			m_threadID;					//fR[hpXbhID
extern int			m_firstSync;				//ŏ̓wb_ʒu
extern int			m_firstSample;				//Tv̈ʒu
extern double		m_msPerFrame;				//1t[̉tԁi~bj
extern int			m_state;					//݂̏
extern int			m_stateWork;				//V[NA[Ǝ̌̏
extern int			decodePos;					//ĐԌvZp

extern BYTE*		m_inputBuf;					//̓obt@iMPEG Audioj
extern BYTE*		m_inputPtr;					//̓|C^
extern int			m_inputSize;				//̓obt@TCY
extern int			m_inputBytes;				//fR[hĂȂobt@TCY
extern BYTE*		m_outputBuf_in;				//o̓obt@iPCMj
extern int			m_readWaveDataSize;			//WAVEǍTCY
extern int			m_frameReadFlag;			//t[擾@ 0:ʏ 1:t@CS
extern BOOL			m_seekFlag;					//V[NȂ TRUE
extern BOOL			m_reloadFlag;				//[hȂ TRUE
extern BOOL			m_stepFlag;					//TRUE:ςȂsb`ύX
extern BOOL			m_seekPlayFlag;				//TRUE:~ɃV[NꂽƂĐJn
extern BOOL			m_playFlag;					//PłĐꂽ TRUE
extern BOOL			m_quickSeek;				//V[Nsꍇ TRUE

/* R[obN֘A */
extern INPUT_MSG_PROC	m_pProc;				//R[obN֐
extern int				m_userData;				//R[obN֐p[^
extern BOOL			callBackFlag;				//R[obN֐gpL
extern TIMER_PROC	m_pTimerProc;				//R[obN^C}֐
extern BOOL			callBackTimerFlag;			//R[obN^C}֐gpL
extern int			m_timerUserData;			//R[obN^C}֐p[^
extern UINT			m_timerId;					//^C}[ID
extern BOOL			m_timeCall;					//^C}[R[tO
extern BOOL			m_OnCall;					//R[obN

/* ̎֘A */
extern LYRICS_WORK	m_lyrics[1000];				//̎
extern int			m_liricsLinePointMax[1000];	//s̃^O
extern int			m_lyricsCount;				//^O
extern int			m_lyricsLineNo;				//̎s
extern int			m_lyricsCurrent;			//Jgʒu 0`1000
extern int			m_lyricsTotalFlag;			//̎\Ɏgp鎞(0:Winamp݊ 1:W 2:ݒ背[g)
extern long			m_lyricsAdjustTime;			//̎ؑ֒
extern long			m_lyricsNextAdjustTime;		//̎sؑ֒
extern BOOL			m_Lyrics3UseFlag;			//Lyrics3 ̎gpI
extern BOOL			m_KaraokeTagFlag;			//JIP^OgpI
extern BOOL			m_ExistKaraokeTag;			//JIP^O̗L
extern BOOL			m_ExistTimeTag;				//^C^O̗L
extern int			m_Lyrics3InsertPoint;		//LYRICS3^O}ʒu 0:ILYC 1:IID3 2:
extern int			m_NotTagLineRead;			//̎̋sǍ 0: 1:L
extern AT_TAG		m_atTag;					//^Of[^
extern int			m_atTagUseFlag;				//̈ 0: 1:^Ogp 2:Jns
extern double		m_timeRatio;				//ԗ

/* ^O֘A */
extern int			m_listChunkPoint;			//`Nʒuۑp
extern int			m_listChunkSize;			//`NTCYۑp
extern int			RiffStatus;					//MpegCheck
extern int			m_NotDataSiWrite;			//f[^̃tB[h 0: 1:L

/* WAVEt@C֘A */
extern WAVEFORMATEX	m_waveFormat;				//WAVEtH[}bg
extern BOOL			m_waveFlag;					//I[vt@CPCMȂTRUE
extern int			m_outWaveBufSize;			//oWAVEobt@TCY
extern int			m_inWaveBufSize;			//WAVEobt@TCY

//fR[hXbhpbZ[W
enum {
	EV_STOP		= (WM_APP + 0),				//~
	EV_PAUSE	= (WM_APP + 2),				//ꎞ~
	EV_RESTART	= (WM_APP + 3),				//tĊJ
	EV_SEEK		= (WM_APP + 4),				//V[N
	EV_EQUALIZER= (WM_APP + 5),				//CRCU(TvO[g)
	EV_SUSPEND  = (WM_APP + 100), //ǉ by Kobarin
	EV_RESUME  =  (WM_APP + 101), //ǉ by Kobarin
};

//݂̏
//getState֐Ŏ擾ł
enum {
	STATE_STOP	= 0,						//~
	STATE_PLAY	= 1,						//Đ
	STATE_PAUSE	= 2,						//ꎞ~
};

//bZ[Wԍ
//setCallback֐Ŏw肵֐ɓn
#define INPUT_MSG_ERROR			0
#define INPUT_MSG_STOP			1
#define INPUT_MSG_PLAY			2
#define INPUT_MSG_PAUSE			3
#define INPUT_MSG_PLAYDONE		4
#define INPUT_MSG_BITRATE		5
#define INPUT_MSG_WAVE_LEFT		6
#define INPUT_MSG_WAVE_RIGHT	7

//We[u
extern const char *genre_tbl[256];

//VBR pt[ԃe[u
extern const double ms_table[3][3];

//MP3Input
/************* VBMP3 R[֐Q ************/
/** {n **/
BOOL initDec();
BOOL freeDec();
BOOL input_open(const char* pszName, const wchar_t* pszNameW, InputInfo* pInfo);
BOOL input_close();
BOOL input_play();
BOOL input_stop();
BOOL input_pause();
BOOL input_restart();
void input_seekBySec(int sec);
void input_seekByFrame(int frame);
void input_seekBySample(int sample);
BOOL input_reload();

/** VBMP3 ֘A **/
int input_getVersion();
BOOL input_SetVbmp3Option(VBMP3_OPTION* pVbmp3Option);
void input_GetVbmp3Option(VBMP3_OPTION* pVbmp3Option);
BOOL input_SetDecodeOption(DEC_OPTION* pDecOption);
void input_GetDecodeOption(DEC_OPTION* pDecOption);
void input_setWaveOutDeviceId(int id);

/** Xe[^X(/rbg[g) **/
int input_getState();
int getTime();
int input_getPlayFrames();
int input_getPlaySamples();
int input_getTotalSamples();
long input_getWinampPlayMs();
int input_getWinampTotalSec();
int input_getPlayBitRate();

/** 擾n **/
int getFileType(const char* pszName, const wchar_t* pszNameW);
int input_getWaveOutSupport();
int input_getSilentFrames(const char* pszName, const wchar_t* pszNameW);
BOOL getMpegInfo(MPEG_INFO* pMpegInfo);
BOOL getFileInfo(const char* pszName, const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo);
BOOL getFileInfo2(const char* pszName, const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo);
BOOL getFileInfoMtr(const char* pszName, const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo,int* pFileType, FILE_TIME *pFileTime);

/** ID3 Tag **/
BOOL setTagInfo(const char* pszName, const wchar_t* pszNameW, TAG_INFO* pTagInfo,int tagSet, int tagAdd);
BOOL getTagInfo(TAG_INFO* pTagInfo);
BOOL getFileTagInfo(const char* pszName, const wchar_t* pszNameW, TAG_INFO* pTagInfo);
BOOL getFileTagInfoEX(const char* pszName, const wchar_t* pszNameW, TAG_INFO_11* pTagInfo);
BOOL setTagInfoEX(const char* pszName, const wchar_t* pszNameW, TAG_INFO_11* pTagInfo,int tagSet, int tagAdd);
BOOL input_GetGenre(TAG_INFO* pTagInfo);
BOOL input_cutID3v2(const char* pszName, const wchar_t* pszNameW);

/** SItB[h **/
BOOL setListInfo(const char* pszName, const wchar_t* pszNameW, LIST_INFO* pListInfo);
BOOL getListInfo(LIST_INFO* pListInfo);
BOOL input_setListInfoEX(const char* pszName, const wchar_t* pszNameW, LIST_INFO_EX* lpListInfo);
BOOL input_getListInfoEX(const char* pszName, const wchar_t* pszNameW, LIST_INFO_EX* lpListInfo);
BOOL setListInfoEX2(HANDLE FileHandle, LIST_INFO_EX2* pListInfo);
void input_setNotDataSiWrite(int writeFlag);

/** ̎֘A(Lyrics3) **/
BOOL input_setFileLyrics3Info(const char* pszName, const wchar_t* pszNameW, LYRICS3_INFO* lpLyrics3Info, int setFlag);
BOOL input_getFileLyrics3Info(const char* pszName, const wchar_t* pszNameW, LYRICS3_INFO* lpLyrics3Info);
BOOL input_readLyrics3Data();
BOOL input_setReadLyrics3Info(const char* pszName, const wchar_t* pszNameW);
void input_setLyrics3InsField(int field);
void input_setLyrics3Use(int useLyrics3);

/** ̎֘A **/
BOOL input_setLyricsFile(const char* pszLyricsName, const wchar_t* pszNameW);
BOOL input_getLyrics(LYRICS_INFO* pLyricsInfo);
BOOL input_getLyrics2(LYRICS_INFO2* pLyricsInfo, int* pLyCnt);
BOOL input_clearLyrics();
BOOL input_checkKaraokeTag();
void input_setKaraokeUse(int useKaraoke);
void input_setLyricsTime(int flag);
void input_setNotTagLyricsLine(int readFlag);
void input_setLyricsAdjustTime(long ms);
void input_setLyricsNextAdjustTime(long ms);
BOOL input_convTimeN2W();
BOOL input_convTimeW2N();
BOOL input_outLyricsFile(const char* pszLyricsName, const wchar_t* pszLyricsNameW);
void input_useAtMarkTag(int useFlag);
void input_setTimeRatio(double timeRatio);
int input_checkTimeTagType();
BOOL input_getCallbackLyricsData(LYRICS_PROC pProc);
void input_getAtTagData(AT_TAG* pAtTagData);
int input_getLyricsData(LYRICS_DATA** pLyricsData, int elmNo);
int	input_getLyricsCount();

/** Đ **/
BOOL input_setStepPitch(int pitch, int frames);
int input_getStepPitch();
BOOL input_setPitch(int pitch);
int input_getPitch();
void input_setFadeIn(int on);
void input_setFadeOut(int on);
void input_fadeOut();
void input_setOverTime(int on);
void input_setFrameReadFlag(int readFlag);
void input_quickSeek(int quickSeekFlag);

/** {[ **/
BOOL input_setVolume(int left, int right);
BOOL input_getVolume(int* left, int* right);
void input_setSoftVolume(int left, int right);
void input_getSoftVolume(int* left, int* right);

/** fR[h **/
BOOL input_playDecodeWave(const char* pszWaveName, const wchar_t* pszWaveNameW);
BOOL input_decodeWave(const char* pszWaveName, const wchar_t* pszWaveNameW);

/** IVEXyAiEOCR **/
void input_getWave(int* pWaveL, int* pWaveR);
void input_getSpectrum(int* pSpecL, int* pSpecR);
void input_setFftWindow(int window);
void input_setEqualizer(int* pTable);

/** t@C`ϊ **/
BOOL input_changeWav(const char* pszName, const wchar_t* pszNameW);
BOOL input_changeMp3(const char* pszName, const wchar_t* pszNameW);
BOOL input_changeRmp(const char* pszName, const wchar_t* pszNameW);
BOOL input_cutMacBinary(const char* pszName, const wchar_t* pszNameW);

/** R[obN֐ **/
BOOL input_setCallback(INPUT_MSG_PROC pProc);
BOOL input_startCallback();
BOOL input_stopCallback();
BOOL input_startCallBackTimer(TIMER_PROC pProc, UINT wDelay, UINT wResolution, int userData);
BOOL input_stopCallBackTimer();
void CALLBACK TimeProc(UINT IDEvent, UINT uReserved, 
					   DWORD dwUser, DWORD dwReserved1, DWORD dwReserved2);

/**************** ֐Q *****************/
/** {n **/
BOOL input_sendEvent(int code, int param);
//int input_ThreadProc();
//int input_decode();
//C by Kobarin
unsigned __stdcall input_ThreadProc(void*);
unsigned input_decode(void*);

void input_handleEvent(const MSG& msg);
void input_actionStop(BOOL wait);
void input_actionPause();
void input_actionRestart();
void input_actionSeek(int sample);


/** VBMP3 ֘A **/
int input_getDecodeOutputSize();
int input_getTotalOutputSize();

/** Xe[^X(/rbg[g) **/
int input_getTotalFrames(const char* pszName, const wchar_t* pszNameW);
long getWinampMs(long samplingRate, long samples);
long getNomalMs(long samplingRate, long samples);
long getFreeRateMs(double TimeRatio, long samples);

/** 擾n **/

/** ID3 Tag **/
static void strcpyID3v1(char* pszDest, const char* pszSrc);
BOOL readID3v1(HANDLE FileHandle, TAG_INFO* lpTagInfo);
BOOL readID3v11(HANDLE FileHandle, TAG_INFO_11* lpTagInfo);
BOOL readID3v2(HANDLE FileHandle,int* fSync);
BOOL setTagInfo11(const char* pszName, const wchar_t* pszNameW, TAG_INFO_11* pTagInfo,int tagSet, int tagAdd);
long getID3v2Size(HANDLE FileHandle,int fSync);

/** SItB[h **/
BOOL readRIFFInfo(InputInfo* pInfo);
BOOL readRIFF(HANDLE FileHandle, LIST_INFO* lplistInfo, int* fSync, DWORD* dSize);
static void loadRMPInfo(LIST_INFO* pInfo, RMPInfo* pRMPInfo);
static void strcpyRMP(char* pszDest, const char* pszSrc, int length, int maxSize);
BOOL getListInfoEX(HANDLE FileHandle, LIST_INFO_EX* lplistInfo);
static void loadRMPInfoEX(LIST_INFO_EX* lplistInfo, RMPInfo* pRMPInfo);
BOOL setListInfoEX(HANDLE FileHandle, LIST_INFO_EX* pListInfo);
BOOL input_setListInfoEX2(const char* pszName, const wchar_t* pszNameW, LIST_INFO_EX2* lpListInfo);
DWORD makeListData(DWORD target, BYTE* pbuf, char* data, const char* key);
BOOL insertFileDataBegin(HANDLE hFileHandle, BYTE* lpData, DWORD dSize);

/** ̎֘A(Lyrics3) **/
BOOL input_readLyrics3(HANDLE FileHandle);
BOOL input_getLyrics3Data(HANDLE hFileHandle, LYRICS3_INFO* lpLyrics3Info);
BOOL chkLYRICS3(HANDLE FileHandle, DWORD* dSize);
BOOL input_convTimeWinamp();

/** ̎֘A **/
int input_checkTimeTag(char* tagData, long* msec);
int input_getTimeLyrics(char* tagData, long* msec, int* lyPoint, int* lyLen, int* nextPoint);
BOOL input_getLyricsText(LYRICS_WORK lyWork, char* buf, int NLFlag);
BOOL checkAtTag(char* buf, int bufSize, AT_TAG* pAtTadData, int LineNo);

/** Đ **/
void input_setSeekPlay(int seekPlayFlag);
int input_getSampleToSeekPoint(int seekSample, int* pOutputBytes);

/** {[ **/
void input_fadeOutVolume();

/** fR[h **/

/** IVEXyAiEOCR **/

/** t@C`ϊ **/

/** R[obN֐ **/
void input_callBackTime();

/**  **/
int input_read(void* pData, int length);
int input_bytesToSample(int bytes);
int input_secToSample(int sec);
int input_msToSample(int sec);
int input_sampleToSec(int sample);
long input_sampleToMs(int sample);
BOOL input_skipNextSync();
BOOL moveFileData(HANDLE hFile,long dataSync, DWORD dataSize, long movePoint);

/** gp **/
void input_startAnalyze();
void input_stopAnalyze();
void input_startAnalyzeThread();
void input_stopAnalyzeThread();

/** J **/
void regRead();

#endif // __MP3INPUT_H__
