/*
 *  This file is part of the VBMP3 package.
 *
 *  VBMP3, MP3 Operating Library
 *  originally Copyright (C) 1999-2000 Daisuke Karikomi
 *
 *  Portions Copyright (C) 2002 Kobarin
 */

#ifndef __MP3OUTPUT_H__
#define __MP3OUTPUT_H__

#include <windows.h>
#include <process.h>
#include <stdio.h>
#include "VBMP3.h"

#pragma comment(lib, "winmm.lib")

struct OutputInfo
{
	int		channels;			//`l
	int		bitsPerSample;		//rbg/1Tv
	int		frequency;
	int		bufferSize;
};

extern HWAVEOUT		m_hWaveOut;					//I[fBIo̓foCX
//HANDLE			m_out_hThread;
//int				m_out_threadID;

//HANDLE			m_hSemaphore;				//f[^ubNpZ}tH
//폜 by Kobarin
extern CRITICAL_SECTION m_cs;						//eϐ p

extern int			m_channels;
extern int			m_bitsPerSample;
extern int			m_blockSize;

extern int			m_outputBlock;
extern int			m_outputIndex;
extern int			m_outputFinished;
extern BYTE**		m_outputTable;

//boolean			m_analyze = false;
//boolean			m_analyzeThread = false;
//int				m_specTableL[256];
//int				m_specTableR[256];

extern int			m_waveBlock;
extern int			m_waveIndex;				//WAVEHDR CfbNX
//int				m_waveStack;				//Đ WAVEHDR 
//int				m_waveCount = 16;				//WAVEHDR z
extern WAVEHDR*		m_waveTable;				//WAVEHDR i[e[u

extern BYTE*		m_outputPtr;
extern int			m_outputBytes;
extern int			m_outputSize;
extern int			m_pitch;					//sb`(%)

/*
BYTE*		m_outputBuf;
BYTE*		m_outputPtr;
int			m_outputSize;
int			m_outputBytes;
*/
extern int			m_outputSleep;

extern int			m_lSoftVol;				//\tgEFA{[()
extern int			m_rSoftVol;				//\tgEFA{[(E)
extern int			m_lMaxSoftVol;			//ő\tgEFA{[()
extern int			m_rMaxSoftVol;			//ő\tgEFA{[(E)
extern BOOL			m_fadeIn;
extern BOOL			m_fadeOut;

extern BOOL			m_stepPitch;

extern int			m_deviceId;		//foCXID

enum {
	rectangle	= 0,
	hanning		= 1,
	hamming		= 2,
	blackman	= 3,
};

extern int			m_fftWindow;

//MP3Output
/*
void output_startAnalyze();
void output_stopAnalyze();
void output_startAnalyzeThread();
void output_stopAnalyzeThread();
*/

void output_setWaveOutDeviceId(int id);

void output_setFftWindow(int window);

int output_getWaveOutSupport();

void output_setSoftVolume(int left, int right);
void output_getSoftVolume(int* left, int* right);

void output_setStepPitch(int pitch);
int output_getStepPitch();
void output_setPitch(int pitch);
int output_getPitch();

BOOL output_SetVbmp3Option(VBMP3_OPTION* pVbmp3Option);
void output_GetVbmp3Option(VBMP3_OPTION* pVbmp3Option);

BOOL initOutput();
BOOL freeOutput();
BOOL output_open(const char* pszName, OutputInfo& info);
BOOL output_close();
int output_write(const void* pData, int length);
DWORD output_wait(DWORD dwWaitTime);//ǉ by Kobarin

BOOL output_stop();
BOOL output_pause();
BOOL output_restart();
BOOL output_setVolume(int left, int right);
BOOL output_getVolume(int* left, int* right);

//void output_getSpectrum(int* pSpecL, int* pSpecR);
int output_getCurrentSample();
int output_getWave(int sample, int* pWaveL, int* pWaveR);
int output_getSpectrum(int sample, int* pSpecL, int* pSpecR);

//int output_ThreadProc();
//void output_analyze();

int output_bytesToSample(int bytes);
int output_sampleToBytes(int sample);
void output_playBlock();

void CALLBACK WaveProc(HWAVEOUT hWaveOut, UINT msg,
		DWORD instance, DWORD param1, DWORD param2);

//WAVE
void output_softVolumeMax();
void output_chgSoftVol( short *buf, int size );
void output_chgSoftVol8( unsigned char *buf, int size );
void output_setFadeIn(int on);
void output_setFadeOut(int on);
void output_chgStepSpeed( short *buf, int size );

void fftCopy(int pos, short s);
void fftTransform(int* spec);

#endif // __MP3OUTPUT_H__
