/*
 *  This file is part of the VBMP3 package.
 *
 *  VBMP3, MP3 Operating Library
 *  originally Copyright (C) 1999-2000 Daisuke Karikomi
 *
 *  Portions Copyright (C) 2000 Yoshi.Matsuo
 *  Portions Copyright (C) 2002 Lenn
 *  Portions Copyright (C) 2016 Downspade
 */

#ifndef __VBMP3_H__
#define __VBMP3_H__

// ̃t@C VBMP3.h  VBMP3 Jp VCMP3AVCMP3 lib t@CŋʂłB
// VCMP3 lib t@Cłł VBMP3_STATIC `܂BLenn

#ifndef VBMP3_STATIC // !VCMP3 lib t@C 2002.10.05. Lenn
#ifdef VBMP3_EXPORTS
#define VBMP3_API __declspec(dllexport)
#else
#define VBMP3_API __declspec(dllimport)
#endif
#else // VBMP3_STATIC
#define VBMP3_API
#endif // VBMP3_STATIC

#include <windows.h>
#include <malloc.h>

// MinGW-gcc  DLL 쐬ƁADLL ŃGNX|[g֐
// C++ ̖OtKKp VC ō쐬̂ƌ݊ȂȂB
// __GNUG__ ̑ __cplusplus gƁAVC ō쐬Ƃ
// C|[gCuIWiƌ݊ȂȂB
// gcc ̂Ƃ̂ C ̖OtKKpB2002.10.05. Lenn
#ifdef __GNUG__
extern "C" {
#endif

#define INFO_NAME_SIZE		128

//t@CI[v擾p
typedef struct
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	int		channels;						//`l
	int		bitRate;						//rbg[g
	int		samplingRate;					//TvO[g
	int		totalSec;						//t
} InputInfo;

//R[obNp`
typedef void (__stdcall *INPUT_MSG_PROC)(int msg, int param);

//ID3 Tagg v1.0
typedef struct
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	char    szAlbumName[INFO_NAME_SIZE];	//Ao
	char	szYear[5];						//[XN
	char	szComment[INFO_NAME_SIZE];		//Rg
	int		genre;							//W
	char    szGanreName[INFO_NAME_SIZE];	//W
} TAG_INFO;

//ID3 Tag v1.1
typedef struct
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	char    szAlbumName[INFO_NAME_SIZE];	//Ao
	char	szYear[5];						//[XN
	char	szComment[INFO_NAME_SIZE];		//Rg
	int		genre;							//W
	char    szGanreName[INFO_NAME_SIZE];	//W
	int		trackNo;						//gbNԍ -1 = v1.0
} TAG_INFO_11;

//MPEG
typedef struct
{
	int		version;		//MPEG̃o[W
	int		layer;			//MPEG̃C
	int		crcDisable;		//G[ی
	int		extension;		//l
	int		mode;			//`l[h
	int		copyright;		//쌠
	int		original;		//IWi
	int		emphasis;		//GtHVX		

	int		channels;		//o̓`l
	int		bitRate;		//rbg[g
	int		samplingRate;	//TvO[g
	int		fileSize;		//t@CTCY
	int		flames;			//t[
	int		totalSec;		//t
} MPEG_INFO;

//̎
typedef struct
{
	long	sec;							//^O(ms)
	char	LyricsNext2[INFO_NAME_SIZE];	//Xɕ\̎
	char	LyricsNext1[INFO_NAME_SIZE];	//ɕ\̎
	char	LyricsCurrent[INFO_NAME_SIZE];	//݂̉̎
	char	LyricsPrev1[INFO_NAME_SIZE];	//Ỏ̎
	char	LyricsPrev2[INFO_NAME_SIZE];	//OX̉̎
} LYRICS_INFO;

//̎(JIP^OΉ)
typedef struct
{
	long	sec;									//^O(ms)
	int		lineno;									//sԍ
	int		point;									//sʒu
	int		length;									//^OԎ(ms)
	char	LyricsNext2[INFO_NAME_SIZE];			//Xɕ\̎
	char	LyricsNext1[INFO_NAME_SIZE];			//ɕ\̎
	char	LyricsCurrent[INFO_NAME_SIZE];			//݂̉̎
	char	LyricsCurrentBegin[INFO_NAME_SIZE];		//݂̉̎(Đς݂̉̎)
	char	LyricsCurrentLyrics[INFO_NAME_SIZE];	//݂̉̎(Đ̉̎)
	char	LyricsCurrentAll[INFO_NAME_SIZE];		//݂̉̎(Psׂ)
	char	LyricsPrev1[INFO_NAME_SIZE];			//Ỏ̎
	char	LyricsPrev2[INFO_NAME_SIZE];			//OX̉̎
} LYRICS_INFO2;

//fR[hIvV
typedef struct
{
	int		reduction;		//TvO 0:1/1 1:1/2 2:1/4 (Default = 0)
	int		convert;		//`l 0:XeI 1:m(Default = 0)
	int		freqLimit;		//g
} DEC_OPTION;

//VBMP3 pIvV
typedef struct
{
	int inputBlock;			//̓t[
	int outputBlock;		//o̓t[
	int inputSleep;			//͒̃X[v(~b)
	int outputSleep;		//o͒̃X[v(~b)
} VBMP3_OPTION;

//SItB[h(FieldMaxSize : 128Byte)
typedef struct
{
	char	INAM[INFO_NAME_SIZE];	//Ȗ
	char	IART[INFO_NAME_SIZE];	//A[eBXg
	char    IPRD[INFO_NAME_SIZE];	//i
	char	ICMT[INFO_NAME_SIZE];	//Rg
	char	ICRD[INFO_NAME_SIZE];	//[XN
	char	IGNR[INFO_NAME_SIZE];	//W
	char    ICOP[INFO_NAME_SIZE];	//쌠
	char    IENG[INFO_NAME_SIZE];	//GWjA
	char    ISRC[INFO_NAME_SIZE];	//\[X
	char    ISFT[INFO_NAME_SIZE];	//\tgEFA
	char    IKEY[INFO_NAME_SIZE];	//L[[h
	char    ITCH[INFO_NAME_SIZE];	//Zp
	char    ILYC[INFO_NAME_SIZE];	//̎
	char    ICMS[INFO_NAME_SIZE];	//R~bV
} LIST_INFO;

#define LIST_SIZE		2048

//SItB[h(FieldMaxSize : 2048Byte)
typedef struct
{
	char	INAM[LIST_SIZE];	//Ȗ
	char	IART[LIST_SIZE];	//A[eBXg
	char    IPRD[LIST_SIZE];	//i
	char	ICMT[LIST_SIZE];	//Rg
	char	ICRD[LIST_SIZE];	//[XN
	char	IGNR[LIST_SIZE];	//W
	char    ICOP[LIST_SIZE];	//쌠
	char    IENG[LIST_SIZE];	//GWjA
	char    ISRC[LIST_SIZE];	//\[X
	char    ISFT[LIST_SIZE];	//\tgEFA
	char    IKEY[LIST_SIZE];	//L[[h
	char    ITCH[LIST_SIZE];	//Zp
	char    ICMS[LIST_SIZE];	//R~bV
	char	IMED[LIST_SIZE];	// 
	char	ISBJ[LIST_SIZE];	//^Cg
	char	IMP3[LIST_SIZE];	//MP3
	char    ILYC[LIST_SIZE];	//̎
} LIST_INFO_EX;

#define LIST_SIZE_VB		512

//SItB[hVBp(FieldMaxSize : 512)
typedef struct
{
	char	INAM[LIST_SIZE_VB];	//Ȗ
	char	IART[LIST_SIZE_VB];	//A[eBXg
	char    IPRD[LIST_SIZE_VB];	//i
	char	ICMT[LIST_SIZE_VB];	//Rg
	char	ICRD[LIST_SIZE_VB];	//[XN
	char	IGNR[LIST_SIZE_VB];	//W
	char    ICOP[LIST_SIZE_VB];	//쌠
	char    IENG[LIST_SIZE_VB];	//GWjA
	char    ISRC[LIST_SIZE_VB];	//\[X
	char    ISFT[LIST_SIZE_VB];	//\tgEFA
	char    IKEY[LIST_SIZE_VB];	//L[[h
	char    ITCH[LIST_SIZE_VB];	//Zp
	char    ICMS[LIST_SIZE_VB];	//R~bV
	char	IMED[LIST_SIZE_VB];	// 
	char	ISBJ[LIST_SIZE_VB];	//^Cg
	char	IMP3[LIST_SIZE_VB];	//MP3
	char    ILYC[LIST_SIZE_VB];	//̎
} LIST_INFO_EX_VB;

//SItB[h(FieldMaxSize : )
typedef struct
{
	char	*INAM;	//Ȗ
	char	*IART;	//A[eBXg
	char    *IPRD;	//i
	char	*ICMT;	//Rg
	char	*ICRD;	//[XN
	char	*IGNR;	//W
	char    *ICOP;	//쌠
	char    *IENG;	//GWjA
	char    *ISRC;	//\[X
	char    *ISFT;	//\tgEFA
	char    *IKEY;	//L[[h
	char    *ITCH;	//Zp
	char    *ICMS;	//R~bV
	char	*IMED;	// 
	char	*ISBJ;	//^Cg
	char	*IMP3;	//MP3
	char    *ILYC;	//̎
} LIST_INFO_EX2;

//WAVEf[^
typedef struct
{
	int		channels;		//`l
	int		bitsPerSample;	//rbg/1Tv
	int		left;			//`lf[^
	int		right;			//E`lf[^
} WAVE_DATA;

//WAVEtH[}bgf[^
typedef struct
{
	int		channels;			//`l
	int		bitsPerSample;		//rbg/1Tv
	int		samplingRate;		//TvO[g
	int		dataSize;			//t@CTCY
} WAVE_FORM;
 
//LYRICS3
typedef struct
{
	char	IND_LYR;		//LYRtB[h̗L '0': '1':L
	char	IND_TIMETAG;	//^C^O̗L '0': '1':L
	char	LYR[60000];		//̎tB[h
	char	INF[60000];		//tB[h
	char	AUT[250];		//쎌^ȎҖ
	char	EAL[250];		//gAo
	char	EAR[250];		//gA[eBXg
	char	ETT[250];		//ggbN^Cg
	char	IMG[60000];		//C[Wt@Cւ̃N
} LYRICS3_INFO;

//LYRICS3VBp
typedef struct
{
	char	IND_LYR;		//LYRtB[h̗L '0': '1':L
	char	IND_TIMETAG;	//^C^O̗L '0': '1':L
	char	AUT[250];		//쎌^ȎҖ
	char	EAL[250];		//gAo
	char	EAR[250];		//gA[eBXg
	char	ETT[250];		//ggbN^Cg
} LYRICS3_INFO_VB;

//t@C
typedef struct
{
	int		fileSize;		//t@CTCY
	int		CreateDate;		//쐬t
	int		CreateTime;		//쐬
	int		LastAccessDate;	//ŏIANZXt
	int		LastAccessTime;	//ŏIANZX
	int		LastWriteDate;	//ŏIt
	int		LastWriteTime;	//ŏI
} FILE_TIME;

//̎
typedef struct
{
	long	no;						//zԍ
	long	sec;					//~b
	int		lineno;					//sԍ 0`
	int		point;					//sʒu 1`
	BOOL	tagFlag;				//^OL
	int		textSize;				//eLXgTCY[byte]
	char	lyrics[INFO_NAME_SIZE];	//̎
} LYRICS_DATA;

//̎擾p`
typedef void (__stdcall *LYRICS_PROC)(LYRICS_DATA* lyricsData);

#define AT_TAG_SIZE		1024

//^O
typedef struct
{
	int		existFlag;				//^O 0: 1:L
	int		lyricsTotalFlag;		//̎\Ɏgp鎞(0:Winamp݊ 1:W 2:ݒ背[g)

	char	Artist[AT_TAG_SIZE];	//A[eBXg
	int		ArtistLine;				//A[eBXgsԍ
	char	Title[AT_TAG_SIZE];		//^Cg
	int		TitleLine;				//^Cgsԍ
	char	Album[AT_TAG_SIZE];		//Ao
	int		AlbumLine;				//Aosԍ
	char	Bgfile[AT_TAG_SIZE];	//wit@C
	int		BgfileLine;				//wit@Csԍ
	char	Bgfolder[AT_TAG_SIZE];	//witH_
	int		BgfolderLine;			//witH_sԍ

	double	TimeRatio;				//Ԕ
	int		TimeRatioLine;			//Ԕsԍ
	int		Offset;					//␳[ms]
	int		OffsetLine;				//␳[ms]sԍ
	int		SilencemSec;			//[ms]
	int		SilencemSecLine;		//[ms]sԍ
	char	TaggingBy[AT_TAG_SIZE];	//^O쐬
	int		TaggingByLine;			//^O쐬ҍsԍ
	char	EditedBy[AT_TAG_SIZE];	//^OC
	int		EditedByLine;			//^OCҍsԍ

	int		Silence;				//t[
	int		SilenceLine;			//t[sԍ
	int		Flames;					//t[
	int		FlamesLine;				//t[sԍ
	int		TotalSec;				//t[s]
	int		TotalSecLine;			//t[s]sԍ
	char	TimeType[AT_TAG_SIZE];	//ĐԎ(WinAmp or Normal)
	int		TimeTypeLine;			//ĐԎ(WinAmp or Normal)sԍ
} AT_TAG;

//^O
typedef struct
{
	char	Artist[AT_TAG_SIZE];	//A[eBXg
	char	Title[AT_TAG_SIZE];		//^Cg
	char	Album[AT_TAG_SIZE];		//Ao
	char	Bgfile[AT_TAG_SIZE];	//wit@C
	char	Bgfolder[AT_TAG_SIZE];	//witH_

	double	TimeRatio;				//Ԕ
	int		Offset;					//␳[ms]
	int		SilencemSec;			//[ms]
	char	TaggingBy[AT_TAG_SIZE];	//^O쐬
	char	EditedBy[AT_TAG_SIZE];	//^OC

	int		Silence;				//t[
	int		Flames;					//t[
	int		TotalSec;				//t[s]
	char	TimeType[AT_TAG_SIZE];	//ĐԎ(WinAmp or Normal)
} AT_TAG_DATA;

//^C}pR[obN`
typedef void (__stdcall *TIMER_PROC)(int state, int bitrate, int sec, int userData);

//bZ[Wԍ
//setCallback֐Ŏw肵֐ɓn
#define MSG_ERROR                 0
#define MSG_STOPING               1
#define MSG_PLAYING               2
#define MSG_PAUSING               3
#define MSG_PLAYDONE              4


// ֐̍Ōɑ啶 W t̂̓Ch

//VBMP3
/** {n **/
VBMP3_API BOOL __stdcall vbmp3_init();
VBMP3_API BOOL __stdcall vbmp3_free();
VBMP3_API BOOL __stdcall vbmp3_open(const char* pszName, InputInfo* pInfo);
VBMP3_API BOOL __stdcall vbmp3_openW(const wchar_t* pszNameW, InputInfo* pInfo);
VBMP3_API BOOL __stdcall vbmp3_close();
VBMP3_API BOOL __stdcall vbmp3_play();
VBMP3_API BOOL __stdcall vbmp3_stop();
VBMP3_API BOOL __stdcall vbmp3_pause();
VBMP3_API BOOL __stdcall vbmp3_restart();
VBMP3_API BOOL __stdcall vbmp3_seek(int seekSec);
VBMP3_API BOOL __stdcall vbmp3_setPlayFlames(int frames);
VBMP3_API BOOL __stdcall vbmp3_setPlayFrames(int frames);
VBMP3_API BOOL __stdcall vbmp3_setPlaySamples(int sample);
VBMP3_API BOOL __stdcall vbmp3_reload();

/** VBMP3 ֘A **/
VBMP3_API int __stdcall vbmp3_getVersion();
VBMP3_API BOOL __stdcall vbmp3_setVbmp3Option(VBMP3_OPTION* pVbmp3Option);
VBMP3_API void __stdcall vbmp3_getVbmp3Option(VBMP3_OPTION* pVbmp3Option);
VBMP3_API BOOL __stdcall vbmp3_setDecodeOption(DEC_OPTION* pDecOption);
VBMP3_API void __stdcall vbmp3_getDecodeOption(DEC_OPTION* pDecOption);
VBMP3_API void __stdcall vbmp3_setWaveOutDeviceId(int id);

/** Xe[^X(/rbg[g) **/
VBMP3_API int __stdcall vbmp3_getState(int* sec);
VBMP3_API int __stdcall vbmp3_getPlayFlames();
VBMP3_API int __stdcall vbmp3_getPlayFrames();
VBMP3_API int __stdcall vbmp3_getPlaySamples();
VBMP3_API int __stdcall vbmp3_getTotalSamples();
VBMP3_API long __stdcall vbmp3_getWinampPlayMs();
VBMP3_API int __stdcall vbmp3_getWinampTotalSec();
VBMP3_API int __stdcall vbmp3_getPlayBitRate();

/** 擾n **/
VBMP3_API int __stdcall vbmp3_getFileType(const char* pszName);
VBMP3_API int __stdcall vbmp3_getFileTypeW(const wchar_t* pszNameW);
VBMP3_API int __stdcall vbmp3_getWaveOutSupport();
VBMP3_API int __stdcall vbmp3_getSilentFrames(const char* pszName);
VBMP3_API int __stdcall vbmp3_getSilentFramesW(const wchar_t* pszNameW);
VBMP3_API BOOL __stdcall vbmp3_getMpegInfo(MPEG_INFO* pMpegInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileInfo(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileInfoW(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileInfo2(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileInfo2W(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileInfoMtr(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo, int* pFileType, FILE_TIME *pFileTime);
VBMP3_API BOOL __stdcall vbmp3_getFileInfoMtrW(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo, int* pFileType, FILE_TIME *pFileTime);

/** ID3 Tag **/
VBMP3_API BOOL __stdcall vbmp3_setTagInfo(const char* pszName, TAG_INFO* pTagInfo, int tagSet, int tagAdd);
VBMP3_API BOOL __stdcall vbmp3_setTagInfoW(const wchar_t* pszNameW, TAG_INFO* pTagInfo, int tagSet, int tagAdd);
VBMP3_API BOOL __stdcall vbmp3_getTagInfo(TAG_INFO* pTagInfo);
VBMP3_API BOOL __stdcall vbmp3_setTagInfoEX(const char* pszName, TAG_INFO_11* pTagInfo, int tagSet, int tagAdd);
VBMP3_API BOOL __stdcall vbmp3_setTagInfoEXW(const wchar_t* pszNameW, TAG_INFO_11* pTagInfo, int tagSet, int tagAdd);
VBMP3_API BOOL __stdcall vbmp3_getFileTagInfo(const char* pszName, TAG_INFO* pTagInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileTagInfoW(const wchar_t* pszNameW, TAG_INFO* pTagInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileTagInfoEX(const char* pszName, TAG_INFO_11* pTagInfo);
VBMP3_API BOOL __stdcall vbmp3_getFileTagInfoEXW(const wchar_t* pszNameW, TAG_INFO_11* pTagInfo);
VBMP3_API BOOL __stdcall vbmp3_getGenre(TAG_INFO* pTagInfo);
VBMP3_API BOOL __stdcall vbmp3_cutID3v2(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_cutID3v2W(const wchar_t* pszNameW);

/** SItB[h **/
VBMP3_API BOOL __stdcall vbmp3_setListInfo(const char* pszName, LIST_INFO* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoW(const wchar_t* pszNameW, LIST_INFO* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getListInfo(LIST_INFO* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoEX(const char* pszName, LIST_INFO_EX* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoEXW(const wchar_t* pszNameW, LIST_INFO_EX* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getListInfoEX(const char* pszName, LIST_INFO_EX* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getListInfoEXW(const wchar_t* pszNameW, LIST_INFO_EX* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoExVB(const char* pszName, LIST_INFO_EX_VB* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoExVBW(const wchar_t* pszNameW, LIST_INFO_EX_VB* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getListInfoExVB(const char* pszName, LIST_INFO_EX_VB* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_getListInfoExVBW(const wchar_t* pszNameW, LIST_INFO_EX_VB* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoEX2(const char* pszName, LIST_INFO_EX2* pListInfo);
VBMP3_API BOOL __stdcall vbmp3_setListInfoEX2W(const wchar_t* pszNameW, LIST_INFO_EX2* pListInfo);

VBMP3_API void __stdcall vbmp3_setNotDataSiWrite(int writeFlag);

/** ̎֘A(Lyrics3) **/
VBMP3_API BOOL __stdcall vbmp3_delFileLyrics3Info(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_delFileLyrics3InfoW(const wchar_t* pszNameW);
VBMP3_API BOOL __stdcall vbmp3_setFileLyrics3Info(const char* pszName, LYRICS3_INFO* pLyrics3Info);
VBMP3_API BOOL __stdcall vbmp3_getFileLyrics3InfoW(const wchar_t* pszNameW, LYRICS3_INFO* pLyrics3Info);
VBMP3_API BOOL __stdcall vbmp3_setFileLyrics3InfoVB(const char* pszName, LYRICS3_INFO_VB* pLyrics3InfoVb, char* lyrData, char* InfData, char* ImgData);
VBMP3_API BOOL __stdcall vbmp3_getFileLyrics3InfoVBW(const wchar_t* pszNameW, LYRICS3_INFO_VB* pLyrics3InfoVb, char* lyrData, char* InfData, char* ImgData);
VBMP3_API BOOL __stdcall vbmp3_readLyrics3Data();
VBMP3_API BOOL __stdcall vbmp3_setReadLyrics3Info(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_setReadLyrics3InfoW(const wchar_t* pszNameW);
VBMP3_API void __stdcall vbmp3_setLyrics3InsField(int field);
VBMP3_API void __stdcall vbmp3_setLyrics3Use(int useLyrics3);

/** ̎֘A **/
VBMP3_API BOOL __stdcall vbmp3_setLyricsFile(const char* pszLyricsName);
VBMP3_API BOOL __stdcall vbmp3_setLyricsFileW(const wchar_t* pszLyricsNameW);
VBMP3_API BOOL __stdcall vbmp3_getLyrics(LYRICS_INFO* pLyricsInfo);
VBMP3_API BOOL __stdcall vbmp3_getLyrics2(LYRICS_INFO2* pLyricsInfo);
VBMP3_API BOOL __stdcall vbmp3_clearLyrics();
VBMP3_API BOOL __stdcall vbmp3_checkKaraokeTag();
VBMP3_API void __stdcall vbmp3_setKaraokeUse(int useKaraoke);
VBMP3_API void __stdcall vbmp3_setLyricsTime(int flag);
VBMP3_API void __stdcall vbmp3_setNotTagLyricsLine(int readFlag);
VBMP3_API void __stdcall vbmp3_setLyricsAdjustTime(long ms);
VBMP3_API void __stdcall vbmp3_setLyricsNextAdjustTime(long ms);
VBMP3_API BOOL __stdcall vbmp3_convTimeN2W();
VBMP3_API BOOL __stdcall vbmp3_convTimeW2N();
VBMP3_API BOOL __stdcall vbmp3_outLyricsFile(const char* pszLyricsName);
VBMP3_API BOOL __stdcall vbmp3_outLyricsFileW(const wchar_t* pszLyricsNameW);
VBMP3_API void __stdcall vbmp3_useAtMarkTag(int useFlag);
VBMP3_API void __stdcall vbmp3_setTimeRatio(double timeRatio);
VBMP3_API int __stdcall vbmp3_checkTimeTag();
//VBMP3_API BOOL __stdcall vbmp3_getFontSize(HWND hWnd, const char* lpsz, int cbString, LPSIZE lpSize);
VBMP3_API BOOL __stdcall vbmp3_getCallbackLyricsData(LYRICS_PROC pProc);
VBMP3_API BOOL __stdcall vbmp3_getAtTagData(AT_TAG_DATA* pAtTagData);
VBMP3_API int __stdcall vbmp3_getLyricsPoint();
VBMP3_API int __stdcall vbmp3_getLyricsData(LYRICS_DATA** pLyricsData, int elmNo);
VBMP3_API int __stdcall	vbmp3_getLyricsCount();

/** Đ **/
VBMP3_API BOOL __stdcall vbmp3_setStepPitch(int pitch, int frames);
VBMP3_API int __stdcall vbmp3_getStepPitch();
VBMP3_API BOOL __stdcall vbmp3_setPitch(int pitch);
VBMP3_API int __stdcall vbmp3_getPitch();
VBMP3_API void __stdcall vbmp3_setFadeIn(int on);
VBMP3_API void __stdcall vbmp3_setFadeOut(int on);
VBMP3_API void __stdcall vbmp3_fadeOut();
VBMP3_API void __stdcall vbmp3_setOverTime(int on);
VBMP3_API void __stdcall vbmp3_setSeekPlay(int seekPlayFlag);
VBMP3_API void __stdcall vbmp3_setFrameReadFlag(int readFlag);
VBMP3_API void __stdcall vbmp3_quickSeek(int quickSeekFlag);

/** {[ **/
VBMP3_API BOOL __stdcall vbmp3_setVolume(int left, int right); // 0`99  100iK
VBMP3_API BOOL __stdcall vbmp3_getVolume(int* left, int* right);
VBMP3_API void __stdcall vbmp3_setSoftVolume(int left, int right);
VBMP3_API void __stdcall vbmp3_getSoftVolume(int* left, int* right);

/** fR[h **/
VBMP3_API BOOL __stdcall vbmp3_playDecodeWave(const char* pszWaveName);
VBMP3_API BOOL __stdcall vbmp3_playDecodeWaveW(const wchar_t* pszWaveNameW);
VBMP3_API BOOL __stdcall vbmp3_decodeWave(const char* pszWaveName);
VBMP3_API BOOL __stdcall vbmp3_decodeWaveW(const wchar_t* pszWaveNameW);

/** GR[hn **/
VBMP3_API int __stdcall  vbmp3_getEncodeState(int* readSize, int* encodeSize);
VBMP3_API BOOL __stdcall vbmp3_encodeOpen(const char* pszWaveName, WAVE_FORM* pWaveForm);
VBMP3_API BOOL __stdcall vbmp3_encodeOpenW(const wchar_t* pszWaveNameW, WAVE_FORM* pWaveForm);
VBMP3_API BOOL __stdcall vbmp3_encodeStart(const char* pszMp3Name);
VBMP3_API BOOL __stdcall vbmp3_encodeStartW(const wchar_t* pszMp3NameW);
VBMP3_API BOOL __stdcall vbmp3_encodeStop();

/** IVEXyAiEOCR **/
VBMP3_API void __stdcall vbmp3_getWave(int* pWaveL, int* pWaveR);
VBMP3_API void __stdcall vbmp3_getSpectrum(int* pSpecL, int* pSpecR);
VBMP3_API void __stdcall vbmp3_setFftWindow(int window);
VBMP3_API void __stdcall vbmp3_setEqualizer(int* pTable);

/** t@C`ϊ **/
VBMP3_API BOOL __stdcall vbmp3_changeWav(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_changeWavW(const wchar_t* pszNameW);
VBMP3_API BOOL __stdcall vbmp3_changeMp3(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_changeMp3W(const wchar_t* pszNameW);
VBMP3_API BOOL __stdcall vbmp3_changeRmp(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_changeRmpW(const wchar_t* pszNameW);
VBMP3_API BOOL __stdcall vbmp3_cutMacBinary(const char* pszName);
VBMP3_API BOOL __stdcall vbmp3_cutMacBinaryW(const wchar_t* pszNameW);

/** R[obN֐ **/
VBMP3_API BOOL __stdcall vbmp3_callback(INPUT_MSG_PROC pProc);
VBMP3_API BOOL __stdcall vbmp3_startCallback();
VBMP3_API BOOL __stdcall vbmp3_stopCallback();
VBMP3_API BOOL __stdcall vbmp3_startCallBackTimer(TIMER_PROC pProc, UINT wDelay, UINT wResolution, int userData);
VBMP3_API BOOL __stdcall vbmp3_stopCallBackTimer();

/** fobO **/
VBMP3_API int __stdcall vbmp3_getLastErrorNo();
VBMP3_API long __stdcall vbmp3_debug();

/** gp **/
VBMP3_API void __stdcall vbmp3_startAnalyze();
VBMP3_API void __stdcall vbmp3_stopAnalyze();
VBMP3_API void __stdcall vbmp3_startAnalyzeThread();
VBMP3_API void __stdcall vbmp3_stopAnalyzeThread();
VBMP3_API BOOL __stdcall vbmp3_getWaveData(WAVE_DATA* pWaveData);

#ifdef __GNUG__
}
#endif
#endif // __VBMP3_H__
