/*
 * VBMP3.cpp : DLL AvP[Vp̃Gg |Cg`܂B
 *
 *  This file is part of the VBMP3 package.
 *
 *  VBMP3, MP3 Operating Library
 *  originally Copyright (C) 1999-2000 Daisuke Karikomi
 *
 *  Portions Copyright (C) 2002 Lenn
 */

#include "MP3Enc.h"
#include "MP3Input.h"
#include "vbmp3_common.h"
#include "VBMP3.h"
#ifndef VBMP3_MINGW // !use MinGW with gcc. Lenn
#include <crtdbg.h>
#endif // !VBMP3_MINGW

// ̃t@C VBMP3.cpp  VBMP3  VCMP3 lib t@CŋʂłB
// VCMP3 lib t@Cłł VBMP3_STATIC `܂BLenn

#ifndef VBMP3_STATIC // !VCMP3 lib t@C 2002.10.05. Lenn
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}
#endif // !VBMP3_STATIC

/** {n **/
VBMP3_API BOOL __stdcall vbmp3_init()
{
#ifndef VBMP3_MINGW // !use MinGW with gcc. Lenn
	/*static int init = 0;
    if(!init){
        int DbgFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
        //DbgFlag |= _CRTDBG_DELAY_FREE_MEM_DF;
        DbgFlag |= _CRTDBG_LEAK_CHECK_DF;
        //DbgFlag |= _CRTDBG_CHECK_ALWAYS_DF;
        _CrtSetDbgFlag(DbgFlag);
    }*/
#endif // !VBMP3_MINGW
    return initDec();
}

VBMP3_API BOOL __stdcall vbmp3_free()
{
	return freeDec();
}

VBMP3_API BOOL __stdcall vbmp3_open(const char* pszName, InputInfo* pInfo)
{
	return input_open(pszName, nullptr, pInfo);
}

VBMP3_API BOOL __stdcall vbmp3_openW(const wchar_t* pszNameW, InputInfo* pInfo)
{
	return input_open(nullptr, pszNameW, pInfo);
}

VBMP3_API BOOL __stdcall vbmp3_close()
{
	return input_close();
}

VBMP3_API BOOL __stdcall vbmp3_play()
{
	return input_play();
}

VBMP3_API BOOL __stdcall vbmp3_stop()
{
	return input_stop();
}

VBMP3_API BOOL __stdcall vbmp3_pause()
{
	return input_pause();
}

VBMP3_API BOOL __stdcall vbmp3_restart()
{
	return input_restart();
}

VBMP3_API BOOL __stdcall vbmp3_seek(int seekSec)
{
	input_seekBySec(seekSec);
	return TRUE;
}

//Xy~X
VBMP3_API BOOL __stdcall vbmp3_setPlayFlames(int frames)
{
	input_seekByFrame(frames);
	return TRUE;
}

VBMP3_API BOOL __stdcall vbmp3_setPlayFrames(int frames)
{
	input_seekByFrame(frames);
	return TRUE;
}

VBMP3_API BOOL __stdcall vbmp3_setPlaySamples(int sample)
{
	input_seekBySample(sample);
	return TRUE;
}

VBMP3_API BOOL __stdcall vbmp3_reload()
{
	return input_reload();
}

/** VBMP3 ֘A **/
VBMP3_API int __stdcall vbmp3_getVersion()
{
	return input_getVersion();
}

VBMP3_API BOOL __stdcall vbmp3_setVbmp3Option(VBMP3_OPTION* pVbmp3Option)
{
	return input_SetVbmp3Option(pVbmp3Option);
}

VBMP3_API void __stdcall vbmp3_getVbmp3Option(VBMP3_OPTION* pVbmp3Option)
{
	input_GetVbmp3Option(pVbmp3Option);
}

VBMP3_API BOOL __stdcall vbmp3_setDecodeOption(DEC_OPTION* pDecOption)
{
	return input_SetDecodeOption(pDecOption);
}

VBMP3_API void __stdcall vbmp3_getDecodeOption(DEC_OPTION* pDecOption)
{
	input_GetDecodeOption(pDecOption);
}

VBMP3_API void __stdcall vbmp3_setWaveOutDeviceId(int id)
{
	input_setWaveOutDeviceId(id);
}

/** Xe[^X(/rbg[g) **/
VBMP3_API int __stdcall vbmp3_getState(int* sec)
{
	*sec = getTime();
	return input_getState();
}

//Xy~X
VBMP3_API int __stdcall vbmp3_getPlayFlames()
{
	return input_getPlayFrames();
}

VBMP3_API int __stdcall vbmp3_getPlayFrames()
{
	return input_getPlayFrames();
}

VBMP3_API int __stdcall vbmp3_getPlaySamples()
{
	return input_getPlaySamples();
}

VBMP3_API int __stdcall vbmp3_getTotalSamples()
{
	return input_getTotalSamples();
}

VBMP3_API long __stdcall vbmp3_getWinampPlayMs()
{
	return input_getWinampPlayMs();
}

VBMP3_API int __stdcall vbmp3_getWinampTotalSec()
{
	return input_getWinampTotalSec();
}

VBMP3_API int __stdcall vbmp3_getPlayBitRate()
{
	return input_getPlayBitRate();
}

/** 擾n **/
VBMP3_API int __stdcall vbmp3_getFileType(const char* pszName)
{
	return getFileType(pszName, nullptr);
}

VBMP3_API int __stdcall vbmp3_getFileTypeW(const wchar_t* pszNameW)
{
	return getFileType(nullptr, pszNameW);
}

VBMP3_API int __stdcall vbmp3_getWaveOutSupport()
{
	return input_getWaveOutSupport();
}

VBMP3_API int __stdcall vbmp3_getSilentFrames(const char* pszName)
{
	return input_getSilentFrames(pszName, nullptr);
}

VBMP3_API int __stdcall vbmp3_getSilentFramesW(const wchar_t* pszNameW)
{
	return input_getSilentFrames(nullptr, pszNameW);
}

VBMP3_API BOOL __stdcall vbmp3_getMpegInfo(MPEG_INFO* pMpegInfo)
{
	return getMpegInfo(pMpegInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileInfo(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo)
{
	return getFileInfo(pszName, nullptr, pTagInfo, pMpegInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileInfoW(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo)
{
	return getFileInfo(nullptr, pszNameW, pTagInfo, pMpegInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileInfo2(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo)
{
	return getFileInfo2(pszName, nullptr, pTagInfo, pMpegInfo, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileInfo2W(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo)
{
	return getFileInfo2(nullptr, pszNameW, pTagInfo, pMpegInfo, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileInfoMtr(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo, int* pFileType, FILE_TIME *pFileTime)
{
	return getFileInfoMtr(pszName, nullptr, pTagInfo, pMpegInfo, pListInfo, pFileType, pFileTime);
}

VBMP3_API BOOL __stdcall vbmp3_getFileInfoMtrW(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo, int* pFileType, FILE_TIME *pFileTime)
{
	return getFileInfoMtr(nullptr, pszNameW, pTagInfo, pMpegInfo, pListInfo, pFileType, pFileTime);
}

VBMP3_API BOOL __stdcall vbmp3_convTimeN2W()
{
	return input_convTimeN2W();
}

VBMP3_API BOOL __stdcall vbmp3_convTimeW2N()
{
	return input_convTimeW2N();
}

VBMP3_API BOOL __stdcall vbmp3_outLyricsFile(const char* pszLyricsName)
{
	return input_outLyricsFile(pszLyricsName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_outLyricsFileW(const wchar_t* pszLyricsNameW)
{
	return input_outLyricsFile(nullptr, pszLyricsNameW);
}

/** ID3 Tag **/
VBMP3_API BOOL __stdcall vbmp3_setTagInfo(const char* pszName, TAG_INFO* pTagInfo, int tagSet, int tagAdd)
{
	return setTagInfo(pszName, nullptr, pTagInfo, tagSet, tagAdd);
}

VBMP3_API BOOL __stdcall vbmp3_setTagInfoW(const wchar_t* pszNameW, TAG_INFO* pTagInfo, int tagSet, int tagAdd)
{
	return setTagInfo(nullptr, pszNameW, pTagInfo, tagSet, tagAdd);
}

VBMP3_API BOOL __stdcall vbmp3_getTagInfo(TAG_INFO* pTagInfo)
{
	return getTagInfo(pTagInfo);
}

VBMP3_API BOOL __stdcall vbmp3_setTagInfoEX(const char* pszName, TAG_INFO_11* pTagInfo, int tagSet, int tagAdd)
{
	return setTagInfoEX(pszName, nullptr, pTagInfo, tagSet, tagAdd);
}

VBMP3_API BOOL __stdcall vbmp3_setTagInfoEXW(const wchar_t* pszNameW, TAG_INFO_11* pTagInfo, int tagSet, int tagAdd)
{
	return setTagInfoEX(nullptr, pszNameW, pTagInfo, tagSet, tagAdd);
}

VBMP3_API BOOL __stdcall vbmp3_getFileTagInfo(const char* pszName, TAG_INFO* pTagInfo)
{
	return getFileTagInfo(pszName, nullptr, pTagInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileTagInfoW(const wchar_t* pszNameW, TAG_INFO* pTagInfo)
{
	return getFileTagInfo(nullptr, pszNameW, pTagInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileTagInfoEX(const char* pszName, TAG_INFO_11* pTagInfo)
{
	return getFileTagInfoEX(pszName, nullptr, pTagInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getFileTagInfoEXW(const wchar_t* pszNameW, TAG_INFO_11* pTagInfo)
{
	return getFileTagInfoEX(nullptr, pszNameW, pTagInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getGenre(TAG_INFO* pTagInfo)
{
	return input_GetGenre(pTagInfo);
}

VBMP3_API BOOL __stdcall vbmp3_cutID3v2(const char* pszName)
{
	return input_cutID3v2(pszName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_cutID3v2W(const wchar_t* pszNameW)
{
	return input_cutID3v2(nullptr, pszNameW);
}

/** SItB[h **/
VBMP3_API BOOL __stdcall vbmp3_setListInfo(const char* pszName, LIST_INFO* pListInfo)
{
	return setListInfo(pszName, nullptr, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_setListInfoW(const wchar_t* pszNameW, LIST_INFO* pListInfo)
{
	return setListInfo(nullptr, pszNameW, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getListInfo(LIST_INFO* pListInfo)
{
	return getListInfo(pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_setListInfoEX(const char* pszName, LIST_INFO_EX* pListInfo)
{
	return input_setListInfoEX(pszName, nullptr, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_setListInfoEXW(const wchar_t* pszNameW, LIST_INFO_EX* pListInfo)
{
	return input_setListInfoEX(nullptr, pszNameW, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getListInfoEX(const char* pszName, LIST_INFO_EX* pListInfo)
{
	return input_getListInfoEX(pszName, nullptr, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getListInfoEXW(const wchar_t* pszNameW, LIST_INFO_EX* pListInfo)
{
	return input_getListInfoEX(nullptr, pszNameW, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getListInfoExVB(const char* pszName, LIST_INFO_EX_VB* pListInfo)
{
	LIST_INFO_EX lListInfo;

	::memset(pListInfo, 0, sizeof(LIST_INFO_EX_VB));

	if (!(input_getListInfoEX(pszName, nullptr, &lListInfo))) {
		return FALSE;
	}
	else {
		::memcpy(pListInfo->INAM, lListInfo.INAM, LIST_SIZE_VB);
		::memcpy(pListInfo->IART, lListInfo.IART, LIST_SIZE_VB);
		::memcpy(pListInfo->IPRD, lListInfo.IPRD, LIST_SIZE_VB);
		::memcpy(pListInfo->ICMT, lListInfo.ICMT, LIST_SIZE_VB);
		::memcpy(pListInfo->ICRD, lListInfo.ICRD, LIST_SIZE_VB);
		::memcpy(pListInfo->IGNR, lListInfo.IGNR, LIST_SIZE_VB);
		::memcpy(pListInfo->ICOP, lListInfo.ICOP, LIST_SIZE_VB);
		::memcpy(pListInfo->IENG, lListInfo.IENG, LIST_SIZE_VB);
		::memcpy(pListInfo->ISRC, lListInfo.ISRC, LIST_SIZE_VB);
		::memcpy(pListInfo->ISFT, lListInfo.ISFT, LIST_SIZE_VB);
		::memcpy(pListInfo->IKEY, lListInfo.IKEY, LIST_SIZE_VB);
		::memcpy(pListInfo->ITCH, lListInfo.ITCH, LIST_SIZE_VB);
		::memcpy(pListInfo->ICMS, lListInfo.ICMS, LIST_SIZE_VB);
		::memcpy(pListInfo->IMED, lListInfo.IMED, LIST_SIZE_VB);
		::memcpy(pListInfo->ISBJ, lListInfo.ISBJ, LIST_SIZE_VB);
		::memcpy(pListInfo->IMP3, lListInfo.IMP3, LIST_SIZE_VB);
		::memcpy(pListInfo->ILYC, lListInfo.ILYC, LIST_SIZE_VB);
		return TRUE;
	}
}

VBMP3_API BOOL __stdcall vbmp3_getListInfoExVBW(const wchar_t* pszNameW, LIST_INFO_EX_VB* pListInfo)
{
	LIST_INFO_EX lListInfo;

	::memset(pListInfo, 0, sizeof(LIST_INFO_EX_VB));

	if (!(input_getListInfoEX(nullptr, pszNameW, &lListInfo))) {
		return FALSE;
	}
	else {
		::memcpy(pListInfo->INAM, lListInfo.INAM, LIST_SIZE_VB);
		::memcpy(pListInfo->IART, lListInfo.IART, LIST_SIZE_VB);
		::memcpy(pListInfo->IPRD, lListInfo.IPRD, LIST_SIZE_VB);
		::memcpy(pListInfo->ICMT, lListInfo.ICMT, LIST_SIZE_VB);
		::memcpy(pListInfo->ICRD, lListInfo.ICRD, LIST_SIZE_VB);
		::memcpy(pListInfo->IGNR, lListInfo.IGNR, LIST_SIZE_VB);
		::memcpy(pListInfo->ICOP, lListInfo.ICOP, LIST_SIZE_VB);
		::memcpy(pListInfo->IENG, lListInfo.IENG, LIST_SIZE_VB);
		::memcpy(pListInfo->ISRC, lListInfo.ISRC, LIST_SIZE_VB);
		::memcpy(pListInfo->ISFT, lListInfo.ISFT, LIST_SIZE_VB);
		::memcpy(pListInfo->IKEY, lListInfo.IKEY, LIST_SIZE_VB);
		::memcpy(pListInfo->ITCH, lListInfo.ITCH, LIST_SIZE_VB);
		::memcpy(pListInfo->ICMS, lListInfo.ICMS, LIST_SIZE_VB);
		::memcpy(pListInfo->IMED, lListInfo.IMED, LIST_SIZE_VB);
		::memcpy(pListInfo->ISBJ, lListInfo.ISBJ, LIST_SIZE_VB);
		::memcpy(pListInfo->IMP3, lListInfo.IMP3, LIST_SIZE_VB);
		::memcpy(pListInfo->ILYC, lListInfo.ILYC, LIST_SIZE_VB);
		return TRUE;
	}
}

VBMP3_API BOOL __stdcall vbmp3_setListInfoExVB(const char* pszName, LIST_INFO_EX_VB* pListInfo)
{
	LIST_INFO_EX lListInfo;
	::memset(&lListInfo, ' ', sizeof(LIST_INFO_EX));

	::memcpy(lListInfo.INAM, pListInfo->INAM, LIST_SIZE_VB);
	::memcpy(lListInfo.IART, pListInfo->IART, LIST_SIZE_VB);
	::memcpy(lListInfo.IPRD, pListInfo->IPRD, LIST_SIZE_VB);
	::memcpy(lListInfo.ICMT, pListInfo->ICMT, LIST_SIZE_VB);
	::memcpy(lListInfo.ICRD, pListInfo->ICRD, LIST_SIZE_VB);
	::memcpy(lListInfo.IGNR, pListInfo->IGNR, LIST_SIZE_VB);
	::memcpy(lListInfo.ICOP, pListInfo->ICOP, LIST_SIZE_VB);
	::memcpy(lListInfo.IENG, pListInfo->IENG, LIST_SIZE_VB);
	::memcpy(lListInfo.ISRC, pListInfo->ISRC, LIST_SIZE_VB);
	::memcpy(lListInfo.ISFT, pListInfo->ISFT, LIST_SIZE_VB);
	::memcpy(lListInfo.IKEY, pListInfo->IKEY, LIST_SIZE_VB);
	::memcpy(lListInfo.ITCH, pListInfo->ITCH, LIST_SIZE_VB);
	::memcpy(lListInfo.ICMS, pListInfo->ICMS, LIST_SIZE_VB);
	::memcpy(lListInfo.IMED, pListInfo->IMED, LIST_SIZE_VB);
	::memcpy(lListInfo.ISBJ, pListInfo->ISBJ, LIST_SIZE_VB);
	::memcpy(lListInfo.IMP3, pListInfo->IMP3, LIST_SIZE_VB);
	::memcpy(lListInfo.ILYC, pListInfo->ILYC, LIST_SIZE_VB);

	return input_setListInfoEX(pszName, nullptr, &lListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_setListInfoExVBW(const wchar_t* pszNameW, LIST_INFO_EX_VB* pListInfo)
{
	LIST_INFO_EX lListInfo;
	::memset(&lListInfo, ' ', sizeof(LIST_INFO_EX));

	::memcpy(lListInfo.INAM, pListInfo->INAM, LIST_SIZE_VB);
	::memcpy(lListInfo.IART, pListInfo->IART, LIST_SIZE_VB);
	::memcpy(lListInfo.IPRD, pListInfo->IPRD, LIST_SIZE_VB);
	::memcpy(lListInfo.ICMT, pListInfo->ICMT, LIST_SIZE_VB);
	::memcpy(lListInfo.ICRD, pListInfo->ICRD, LIST_SIZE_VB);
	::memcpy(lListInfo.IGNR, pListInfo->IGNR, LIST_SIZE_VB);
	::memcpy(lListInfo.ICOP, pListInfo->ICOP, LIST_SIZE_VB);
	::memcpy(lListInfo.IENG, pListInfo->IENG, LIST_SIZE_VB);
	::memcpy(lListInfo.ISRC, pListInfo->ISRC, LIST_SIZE_VB);
	::memcpy(lListInfo.ISFT, pListInfo->ISFT, LIST_SIZE_VB);
	::memcpy(lListInfo.IKEY, pListInfo->IKEY, LIST_SIZE_VB);
	::memcpy(lListInfo.ITCH, pListInfo->ITCH, LIST_SIZE_VB);
	::memcpy(lListInfo.ICMS, pListInfo->ICMS, LIST_SIZE_VB);
	::memcpy(lListInfo.IMED, pListInfo->IMED, LIST_SIZE_VB);
	::memcpy(lListInfo.ISBJ, pListInfo->ISBJ, LIST_SIZE_VB);
	::memcpy(lListInfo.IMP3, pListInfo->IMP3, LIST_SIZE_VB);
	::memcpy(lListInfo.ILYC, pListInfo->ILYC, LIST_SIZE_VB);

	return input_setListInfoEX(nullptr, pszNameW, &lListInfo);
}


VBMP3_API BOOL __stdcall vbmp3_setListInfoEX2(const char* pszName, LIST_INFO_EX2* pListInfo)
{
	return input_setListInfoEX2(pszName, nullptr, pListInfo);
}

VBMP3_API BOOL __stdcall vbmp3_setListInfoEX2W(const wchar_t* pszNameW, LIST_INFO_EX2* pListInfo)
{
	return input_setListInfoEX2(nullptr, pszNameW, pListInfo);
}

VBMP3_API void __stdcall vbmp3_setNotDataSiWrite(int writeFlag)
{
	input_setNotDataSiWrite(writeFlag);
}

/** ̎֘A(Lyrics3) **/
VBMP3_API BOOL __stdcall vbmp3_delFileLyrics3Info(const char* pszName)
{
	LYRICS3_INFO Lyrics3Info;
	return input_setFileLyrics3Info(pszName, nullptr, &Lyrics3Info, 0);
}

VBMP3_API BOOL __stdcall vbmp3_delFileLyrics3InfoW(const wchar_t* pszNameW)
{
	LYRICS3_INFO Lyrics3Info;
	return input_setFileLyrics3Info(nullptr, pszNameW, &Lyrics3Info, 0);
}

VBMP3_API BOOL __stdcall vbmp3_setFileLyrics3Info(const char* pszName, LYRICS3_INFO* pLyrics3Info)
{
	return input_setFileLyrics3Info(pszName, nullptr, pLyrics3Info, 1);
}

VBMP3_API BOOL __stdcall vbmp3_setFileLyrics3InfoW(const wchar_t* pszName, LYRICS3_INFO* pLyrics3Info)
{
	return input_setFileLyrics3Info(nullptr, pszName, pLyrics3Info, 1);
}

VBMP3_API BOOL __stdcall vbmp3_getFileLyrics3Info(const char* pszName, LYRICS3_INFO* pLyrics3Info)
{
	return input_getFileLyrics3Info(pszName, nullptr, pLyrics3Info);
}

VBMP3_API BOOL __stdcall vbmp3_getFileLyrics3InfoW(const wchar_t* pszName, LYRICS3_INFO* pLyrics3Info)
{
	return input_getFileLyrics3Info(nullptr, pszName, pLyrics3Info);
}

VBMP3_API BOOL __stdcall vbmp3_setFileLyrics3InfoVB(const char* pszName, LYRICS3_INFO_VB* pLyrics3InfoVb, char* lyrData, char* InfData, char* ImgData)
{
	LYRICS3_INFO lyrics3Info;

	::memcpy(lyrics3Info.LYR, lyrData, 60000);
	::memcpy(lyrics3Info.INF, InfData, 60000);
	::memcpy(lyrics3Info.IMG, ImgData, 60000);

	lyrics3Info.IND_LYR = pLyrics3InfoVb->IND_LYR;
	lyrics3Info.IND_TIMETAG = pLyrics3InfoVb->IND_TIMETAG;

	::memcpy(lyrics3Info.AUT, pLyrics3InfoVb->AUT, 250);
	::memcpy(lyrics3Info.EAL, pLyrics3InfoVb->EAL, 250);
	::memcpy(lyrics3Info.EAR, pLyrics3InfoVb->EAR, 250);
	::memcpy(lyrics3Info.ETT, pLyrics3InfoVb->ETT, 250);

	return input_setFileLyrics3Info(pszName, nullptr, &lyrics3Info, 1);
}

VBMP3_API BOOL __stdcall vbmp3_setFileLyrics3InfoVBW(const wchar_t* pszNameW, LYRICS3_INFO_VB* pLyrics3InfoVb, char* lyrData, char* InfData, char* ImgData)
{
	LYRICS3_INFO lyrics3Info;

	::memcpy(lyrics3Info.LYR, lyrData, 60000);
	::memcpy(lyrics3Info.INF, InfData, 60000);
	::memcpy(lyrics3Info.IMG, ImgData, 60000);

	lyrics3Info.IND_LYR = pLyrics3InfoVb->IND_LYR;
	lyrics3Info.IND_TIMETAG = pLyrics3InfoVb->IND_TIMETAG;

	::memcpy(lyrics3Info.AUT, pLyrics3InfoVb->AUT, 250);
	::memcpy(lyrics3Info.EAL, pLyrics3InfoVb->EAL, 250);
	::memcpy(lyrics3Info.EAR, pLyrics3InfoVb->EAR, 250);
	::memcpy(lyrics3Info.ETT, pLyrics3InfoVb->ETT, 250);

	return input_setFileLyrics3Info(nullptr, pszNameW, &lyrics3Info, 1);
}

VBMP3_API BOOL __stdcall vbmp3_getFileLyrics3InfoVB(const char* pszName, LYRICS3_INFO_VB* pLyrics3InfoVb, char* lyrData, char* InfData, char* ImgData)
{
	LYRICS3_INFO lyrics3Info;

	::memset(pLyrics3InfoVb, 0, sizeof(LYRICS3_INFO_VB));
	::memset(lyrData, 0, 60000);
	::memset(lyrData, 0, 60000);
	::memset(lyrData, 0, 60000);

	if (!(input_getFileLyrics3Info(pszName, nullptr, &lyrics3Info))) {
		return FALSE;
	}
	else {
		::memcpy(lyrData, lyrics3Info.LYR, 60000);
		::memcpy(InfData, lyrics3Info.INF, 60000);
		::memcpy(ImgData, lyrics3Info.IMG, 60000);

		pLyrics3InfoVb->IND_LYR = lyrics3Info.IND_LYR;
		pLyrics3InfoVb->IND_TIMETAG = lyrics3Info.IND_TIMETAG;
		::memcpy(pLyrics3InfoVb->AUT, lyrics3Info.AUT, 250);
		::memcpy(pLyrics3InfoVb->EAL, lyrics3Info.EAL, 250);
		::memcpy(pLyrics3InfoVb->EAR, lyrics3Info.EAR, 250);
		::memcpy(pLyrics3InfoVb->ETT, lyrics3Info.ETT, 250);
		return TRUE;
	}
}

VBMP3_API BOOL __stdcall vbmp3_getFileLyrics3InfoVBW(const wchar_t* pszNameW, LYRICS3_INFO_VB* pLyrics3InfoVb, char* lyrData, char* InfData, char* ImgData)
{
	LYRICS3_INFO lyrics3Info;

	::memset(pLyrics3InfoVb, 0, sizeof(LYRICS3_INFO_VB));
	::memset(lyrData, 0, 60000);
	::memset(lyrData, 0, 60000);
	::memset(lyrData, 0, 60000);

	if (!(input_getFileLyrics3Info(nullptr, pszNameW, &lyrics3Info))) {
		return FALSE;
	}
	else {
		::memcpy(lyrData, lyrics3Info.LYR, 60000);
		::memcpy(InfData, lyrics3Info.INF, 60000);
		::memcpy(ImgData, lyrics3Info.IMG, 60000);

		pLyrics3InfoVb->IND_LYR = lyrics3Info.IND_LYR;
		pLyrics3InfoVb->IND_TIMETAG = lyrics3Info.IND_TIMETAG;
		::memcpy(pLyrics3InfoVb->AUT, lyrics3Info.AUT, 250);
		::memcpy(pLyrics3InfoVb->EAL, lyrics3Info.EAL, 250);
		::memcpy(pLyrics3InfoVb->EAR, lyrics3Info.EAR, 250);
		::memcpy(pLyrics3InfoVb->ETT, lyrics3Info.ETT, 250);
		return TRUE;
	}
}

VBMP3_API BOOL __stdcall vbmp3_readLyrics3Data()
{
	return input_readLyrics3Data();
}

VBMP3_API BOOL __stdcall vbmp3_setReadLyrics3Info(const char* pszName)
{
	return input_setReadLyrics3Info(pszName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_setReadLyrics3InfoW(const wchar_t* pszNameW)
{
	return input_setReadLyrics3Info(nullptr, pszNameW);
}

VBMP3_API void __stdcall vbmp3_setLyrics3InsField(int field)
{
	input_setLyrics3InsField(field);
}

VBMP3_API void __stdcall vbmp3_setLyrics3Use(int useLyrics3)
{
	input_setLyrics3Use(useLyrics3);
}

/** ̎֘A **/
VBMP3_API BOOL __stdcall vbmp3_setLyricsFile(const char* pszLyricsName)
{
	return input_setLyricsFile(pszLyricsName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_setLyricsFileW(const wchar_t* pszLyricsName)
{
	return input_setLyricsFile(nullptr, pszLyricsName);
}

VBMP3_API BOOL __stdcall vbmp3_getLyrics(LYRICS_INFO* pLyricsInfo)
{
	return input_getLyrics(pLyricsInfo);
}

VBMP3_API BOOL __stdcall vbmp3_getLyrics2(LYRICS_INFO2* pLyricsInfo)
{
	int point;
	return input_getLyrics2(pLyricsInfo, &point);
}

VBMP3_API BOOL __stdcall vbmp3_clearLyrics()
{
	return input_clearLyrics();
}

VBMP3_API BOOL __stdcall vbmp3_checkKaraokeTag()
{
	return input_checkKaraokeTag();
}

VBMP3_API void __stdcall vbmp3_setKaraokeUse(int useKaraoke)
{
	input_setKaraokeUse(useKaraoke);
}

VBMP3_API void __stdcall vbmp3_setLyricsTime(int flag)
{
	input_setLyricsTime(flag);
}

VBMP3_API void __stdcall vbmp3_setNotTagLyricsLine(int readFlag)
{
	input_setNotTagLyricsLine(readFlag);
}


VBMP3_API void __stdcall vbmp3_setLyricsAdjustTime(long ms)
{
	input_setLyricsAdjustTime(ms);
}

VBMP3_API void __stdcall vbmp3_setLyricsNextAdjustTime(long ms)
{
	input_setLyricsNextAdjustTime(ms);
}

VBMP3_API void __stdcall vbmp3_useAtMarkTag(int useFlag)
{
	input_useAtMarkTag(useFlag);
}

VBMP3_API void __stdcall vbmp3_setTimeRatio(double timeRatio)
{
	input_setTimeRatio(timeRatio);
}

VBMP3_API int __stdcall vbmp3_checkTimeTag()
{
	return input_checkTimeTagType();
}

VBMP3_API BOOL __stdcall vbmp3_getCallbackLyricsData(LYRICS_PROC pProc)
{
	return input_getCallbackLyricsData(pProc);
}

VBMP3_API BOOL __stdcall vbmp3_getAtTagData(AT_TAG_DATA* pAtTagData){
	AT_TAG		atTagWork;
	input_getAtTagData(&atTagWork);

	if ( atTagWork.existFlag == 0 ) return FALSE;

	::memcpy(pAtTagData->Artist, atTagWork.Artist, AT_TAG_SIZE);
	::memcpy(pAtTagData->Title, atTagWork.Title, AT_TAG_SIZE);
	::memcpy(pAtTagData->Album, atTagWork.Album, AT_TAG_SIZE);
	::memcpy(pAtTagData->Bgfile, atTagWork.Bgfile, AT_TAG_SIZE);
	::memcpy(pAtTagData->Bgfolder, atTagWork.Bgfolder, AT_TAG_SIZE);
	::memcpy(pAtTagData->TaggingBy, atTagWork.TaggingBy, AT_TAG_SIZE);
	::memcpy(pAtTagData->EditedBy, atTagWork.EditedBy, AT_TAG_SIZE);
	::memcpy(pAtTagData->TimeType, atTagWork.TimeType, AT_TAG_SIZE);
	pAtTagData->TimeRatio = atTagWork.TimeRatio;
	pAtTagData->SilencemSec = atTagWork.SilencemSec;
	pAtTagData->Silence = atTagWork.Silence;
	pAtTagData->Flames = atTagWork.Flames;
	pAtTagData->TotalSec = atTagWork.TotalSec;

	return TRUE;
}

VBMP3_API int __stdcall vbmp3_getLyricsPoint()
{
	LYRICS_INFO2 lyricsInfo;
	int	point;

	input_getLyrics2(&lyricsInfo, &point);
	return point;
}

VBMP3_API int __stdcall vbmp3_getLyricsData(LYRICS_DATA** pLyricsData, int elmNo)
{
	pLyricsData[1]->lineno = 1;
	return TRUE;
	return input_getLyricsData(pLyricsData, elmNo);
}

VBMP3_API int __stdcall	vbmp3_getLyricsCount()
{
	return input_getLyricsCount();
}


/** Đ **/
VBMP3_API BOOL __stdcall vbmp3_setStepPitch(int pitch, int frames)
{
	return input_setStepPitch(pitch, frames);
}

VBMP3_API int __stdcall vbmp3_getStepPitch()
{
	return input_getStepPitch();
}

VBMP3_API BOOL __stdcall vbmp3_setPitch(int pitch)
{
	return input_setPitch(pitch);
}

VBMP3_API int __stdcall vbmp3_getPitch()
{
	return input_getPitch();
}

VBMP3_API void __stdcall vbmp3_setFadeIn(int on)
{
	input_setFadeIn(on);
}

VBMP3_API void __stdcall vbmp3_setFadeOut(int on)
{
	input_setFadeOut(on);
}

VBMP3_API void __stdcall vbmp3_fadeOut()
{
	input_fadeOut();
}

VBMP3_API void __stdcall vbmp3_setOverTime(int on)
{
	input_setOverTime(on);
}

VBMP3_API void __stdcall vbmp3_setSeekPlay(int seekPlayFlag)
{
	input_setSeekPlay(seekPlayFlag);
}

VBMP3_API void __stdcall vbmp3_setFrameReadFlag(int readFlag)
{
	input_setFrameReadFlag(readFlag);
}

VBMP3_API void __stdcall vbmp3_quickSeek(int quickSeekFlag)
{
	input_quickSeek(quickSeekFlag);
}

/** {[ **/
VBMP3_API BOOL __stdcall vbmp3_setVolume(int left, int right)
{
	return input_setVolume(left, right);
}

VBMP3_API BOOL __stdcall vbmp3_getVolume(int* left, int* right)
{
	return input_getVolume(left, right);
}

VBMP3_API void __stdcall vbmp3_setSoftVolume(int left, int right)
{
	input_setSoftVolume(left, right);
}

VBMP3_API void __stdcall vbmp3_getSoftVolume(int* left, int* right)
{
	input_getSoftVolume(left, right);
}

/** fR[h **/
VBMP3_API BOOL __stdcall vbmp3_playDecodeWave(const char* pszWaveName)
{
	return input_playDecodeWave(pszWaveName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_playDecodeWaveW(const wchar_t* pszWaveNameW)
{
	return input_playDecodeWave(nullptr, pszWaveNameW);
}

VBMP3_API BOOL __stdcall vbmp3_decodeWave(const char* pszWaveName)
{
	return input_decodeWave(pszWaveName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_decodeWaveW(const wchar_t* pszWaveNameW)
{
	return input_decodeWave(nullptr, pszWaveNameW);
}

/** GR[hn **/
VBMP3_API int __stdcall  vbmp3_getEncodeState(int* readSize, int* encodeSize)
{
	return enc_getEncodeState(readSize, encodeSize);
}

VBMP3_API BOOL __stdcall vbmp3_encodeOpen(const char* pszWaveName, WAVE_FORM* pWaveForm)
{
	return enc_open(pszWaveName, nullptr, pWaveForm);
}

VBMP3_API BOOL __stdcall vbmp3_encodeOpenW(const wchar_t* pszWaveNameW, WAVE_FORM* pWaveForm)
{
	return enc_open(nullptr, pszWaveNameW, pWaveForm);
}

VBMP3_API BOOL __stdcall vbmp3_encodeStart(const char* pszMp3Name)
{
	return enc_start(pszMp3Name, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_encodeStartW(const wchar_t* pszMp3NameW)
{
	return enc_start(nullptr, pszMp3NameW);
}

VBMP3_API BOOL __stdcall vbmp3_encodeStop()
{
	return enc_stop();
}

/** IVEXyAiEOCR **/
VBMP3_API void __stdcall vbmp3_getWave(int* pWaveL, int* pWaveR)
{
	input_getWave(pWaveL, pWaveR);
}

VBMP3_API void __stdcall vbmp3_getSpectrum(int* pSpecL, int* pSpecR)
{
	input_getSpectrum(pSpecL, pSpecR);
	return;
}

VBMP3_API void __stdcall vbmp3_setFftWindow(int window)
{
	input_setFftWindow(window);
}

VBMP3_API void __stdcall vbmp3_setEqualizer(int* pTable)
{
	input_setEqualizer(pTable);
}

/** t@C`ϊ **/
VBMP3_API BOOL __stdcall vbmp3_changeWav(const char* pszName)
{
	return input_changeWav(pszName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_changeWavW(const wchar_t* pszNameW)
{
	return input_changeWav(nullptr, pszNameW);
}

VBMP3_API BOOL __stdcall vbmp3_changeMp3(const char* pszName)
{
	return input_changeMp3(pszName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_changeMp3W(const wchar_t* pszNameW)
{
	return input_changeMp3(nullptr, pszNameW);
}

VBMP3_API BOOL __stdcall vbmp3_changeRmp(const char* pszName)
{
	return input_changeRmp(pszName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_changeRmpW(const wchar_t* pszNameW)
{
	return input_changeRmp(nullptr, pszNameW);
}

VBMP3_API BOOL __stdcall vbmp3_cutMacBinary(const char* pszName)
{
	return input_cutMacBinary(pszName, nullptr);
}

VBMP3_API BOOL __stdcall vbmp3_cutMacBinaryW(const wchar_t* pszNameW)
{
	return input_cutMacBinary(nullptr, pszNameW);
}

/** R[obN֐ **/
VBMP3_API BOOL __stdcall vbmp3_callback(INPUT_MSG_PROC pProc)
{
	return input_setCallback(pProc);
}

VBMP3_API BOOL __stdcall vbmp3_startCallback()
{
	return input_startCallback();
}

VBMP3_API BOOL __stdcall vbmp3_stopCallback()
{
	return input_stopCallback();
}

VBMP3_API BOOL __stdcall vbmp3_startCallBackTimer(TIMER_PROC pProc, UINT wDelay, UINT wResolution, int userData)
{
	return input_startCallBackTimer(pProc, wDelay, wResolution, userData);
}

VBMP3_API BOOL __stdcall vbmp3_stopCallBackTimer()
{
	return input_stopCallBackTimer();
}

/** fobO **/
VBMP3_API int __stdcall vbmp3_getLastErrorNo()
{
	return _getError();
}

VBMP3_API long __stdcall vbmp3_debug()
{
	return _getDebug();
}

/** gp **/
VBMP3_API BOOL __stdcall vbmp3_getWaveData(WAVE_DATA* pWaveData)
{
	//return input_getWaveData(pWaveData);
	return FALSE;
}

VBMP3_API void __stdcall vbmp3_startAnalyze()
{
	//input_startAnalyze();
}

VBMP3_API void __stdcall vbmp3_stopAnalyze()
{
	//input_stopAnalyze();
}

VBMP3_API void __stdcall vbmp3_startAnalyzeThread()
{
	//input_startAnalyzeThread();
}

VBMP3_API void __stdcall vbmp3_stopAnalyzeThread()
{
	//input_stopAnalyzeThread();
}

