//
// VBMP3.DLL 
// Borlandpgp
//

#define INFO_NAME_SIZE		128

typedef void (__stdcall *INPUT_MSG_PROC)(int msg, int param);

struct InputInfo
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	int		channels;						//`l
	int		bitRate;						//rbg[g
	int		samplingRate;					//TvO[g
	int		totalSec;						//t
};

struct TAG_INFO
{
	char	szTrackName[INFO_NAME_SIZE];	//Ȗ
	char	szArtistName[INFO_NAME_SIZE];	//A[eBXg
	char  szAlbumName[INFO_NAME_SIZE];	//Ao
	char	szYear[5];						//[XN
	char	szComment[INFO_NAME_SIZE];		//Rg
	int		genre;							//W
	char  szGanreName[INFO_NAME_SIZE];	//W
};

struct MPEG_INFO
{
	int		version;		//MPEG̃o[W
	int		layer;			//MPEG̃C
	int		crcDisable;		//G[ی
	int		extension;		//l
	int		mode;			//`l[h
	int		copyright;		//쌠
	int		original;		//IWi
	int		emphasis;		//GtHVX

	int		channels;		//o̓`l
	int		bitRate;		//rbg[g
	int		samplingRate;	//TvO[g
	int		fileSize;		//t@CTCY
	int		flames;			//t[
	int		totalSec;		//t
};

struct LYRICS_INFO
{
	int		sec;
	char	LyricsNext2[INFO_NAME_SIZE];
	char	LyricsNext1[INFO_NAME_SIZE];
	char	LyricsCurrent[INFO_NAME_SIZE];
	char	LyricsPrev1[INFO_NAME_SIZE];
	char	LyricsPrev2[INFO_NAME_SIZE];
};

struct DEC_OPTION{
	int		reduction;		//TvO 0:1/1 1:1/2 2:1/4 (Default = 0)
	int		convert;		//`l 0:XeI 1:m(Default = 0)
	int		freqLimit;		//g
};

struct VBMP3_OPTION
{
	int inputBlock;			//̓t[
	int outputBlock;		//WAVEf[^ubN
	int inputSleep;			//͒̃X[v(~b)
	int outputSleep;		//o͒̃X[v(~b)
};

struct LIST_INFO
{
	char	INAM[INFO_NAME_SIZE];	//Ȗ
	char	IART[INFO_NAME_SIZE];	//A[eBXg
	char  IPRD[INFO_NAME_SIZE];	//i
	char	ICMT[INFO_NAME_SIZE];	//Rg
	char	ICRD[INFO_NAME_SIZE];	//[XN
	char	IGNR[INFO_NAME_SIZE];	//W
	char  ICOP[INFO_NAME_SIZE];	//쌠
	char  IENG[INFO_NAME_SIZE];	//GWjA
	char  ISRC[INFO_NAME_SIZE];	//\[X
	char  ISFT[INFO_NAME_SIZE];	//\tgEFA
	char  IKEY[INFO_NAME_SIZE];	//L[[h
	char  ITCH[INFO_NAME_SIZE];	//Zp
	char  ILYC[INFO_NAME_SIZE];	//̎
	char  ICMS[INFO_NAME_SIZE];	//R~bV
};

struct WAVE_DATA
{
	int		channels;
	int		bitsPerSample;
	int		left;
	int		right;
};

struct WAVE_FORM
{
	int		channels;			//`l
	int		bitsPerSample;		//rbg/1Tv
	int		samplingRate;
	int		dataSize;			//t@CTCY
};

// ============================================================================
//			CVBMP3
// ============================================================================

class	CVBMP3
{
private:
	//  nh
	HANDLE			DllHandle;

	//GR[hn
	int _export pascal (*vbmp3_getEncodeState)(int* readSize, int* encodeSize);
	BOOL _export pascal (*vbmp3_encodeOpen)(const char* pszWaveName, WAVE_FORM* pWaveForm);
	BOOL _export pascal (*vbmp3_encodeOpenW)(const wchar_t* pszWaveNameW, WAVE_FORM* pWaveForm);
	BOOL _export pascal (*vbmp3_encodeStart)(const char* pszMp3Name);
	BOOL _export pascal (*vbmp3_encodeStartW)(const wchar_t* pszMp3NameW);
	BOOL _export pascal (*vbmp3_encodeStop)();

	//gp
	void _export pascal (*vbmp3_startAnalyze)();
	void _export pascal (*vbmp3_stopAnalyze)();
	BOOL _export pascal (*vbmp3_getWaveData)(WAVE_DATA* pWaveData);

	//n
	BOOL _export pascal (*vbmp3_setLyricsFile)(const char* pszLyricsName);
	BOOL _export pascal (*vbmp3_setLyricsFileW)(const wchar_t* pszLyricsNameW);
	BOOL _export pascal (*vbmp3_getLyrics)(LYRICS_INFO* pLyricsInfo);
	void _export pascal (*vbmp3_getSpectrum)(int* pSpecL, int* pSpecR);
	void _export pascal (*vbmp3_getWave)(int* pWaveL, int* pWaveR);

	//R[obN֐
	BOOL _export pascal (*vbmp3_callback)(INPUT_MSG_PROC pProc);
	BOOL _export pascal (*vbmp3_startCallback)();
	BOOL _export pascal (*vbmp3_stopCallback)();

	//t@Co͌n
	BOOL _export pascal (*vbmp3_decodeWave)(const char* pszWaveName);
	BOOL _export pascal (*vbmp3_decodeWaveW)(const wchar_t* pszWaveNameW);
	BOOL _export pascal (*vbmp3_changeWav)(const char* pszName);
	BOOL _export pascal (*vbmp3_changeWavW)(const wchar_t* pszNameW);
	BOOL _export pascal (*vbmp3_changeMp3)(const char* pszName);
	BOOL _export pascal (*vbmp3_changeMp3W)(const wchar_t* pszNameW);
	BOOL _export pascal (*vbmp3_changeRmp)(const char* pszName);
	BOOL _export pascal (*vbmp3_changeRmpW)(const wchar_t* pszNameW);
	BOOL _export pascal (*vbmp3_cutMacBinary)(const char* pszName);
	BOOL _export pascal (*vbmp3_cutMacBinaryW)(const wchar_t* pszNameW);
	BOOL _export pascal (*vbmp3_setTagInfo)(const char* pszName, TAG_INFO* pTagInfo,int tagSet, int tagAdd);
	BOOL _export pascal (*vbmp3_setTagInfoW)(const wchar_t* pszNameW, TAG_INFO* pTagInfo,int tagSet, int tagAdd);
	BOOL _export pascal (*vbmp3_setListInfo)(const char* pszName, LIST_INFO* pListInfo);
	BOOL _export pascal (*vbmp3_setListInfoW)(const wchar_t* pszNameW, LIST_INFO* pListInfo);

	//擾n
	BOOL _export pascal (*vbmp3_getFileInfo2)(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo);
	BOOL _export pascal (*vbmp3_getFileInfo2W)(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo, LIST_INFO* pListInfo);
	BOOL _export pascal (*vbmp3_getFileInfo)(const char* pszName, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo);
	BOOL _export pascal (*vbmp3_getFileInfoW)(const wchar_t* pszNameW, TAG_INFO* pTagInfo, MPEG_INFO* pMpegInfo);
	BOOL _export pascal (*vbmp3_getFileTagInfo)(const char* pszName, TAG_INFO* pTagInfo);
	BOOL _export pascal (*vbmp3_getFileTagInfoW)(const wchar_t* pszNameW, TAG_INFO* pTagInfo);
	BOOL _export pascal (*vbmp3_getListInfo)(LIST_INFO* pListInfo);
	BOOL _export pascal (*vbmp3_getMpegInfo)(MPEG_INFO* pMpegInfo);
	BOOL _export pascal (*vbmp3_getTagInfo)(TAG_INFO* pTagInfo);
	int _export pascal (*vbmp3_getFileType)(const char* pszName);
	int _export pascal (*vbmp3_getFileTypeW)(const wchar_t* pszNameW);
	BOOL _export pascal (*vbmp3_getGenre)(TAG_INFO* pTagInfo);
	long _export pascal (*vbmp3_getWinampPlayMs)();
	int _export pascal (*vbmp3_getWinampTotalSec)();
	int _export pascal (*vbmp3_getPlayBitRate)();
	int _export pascal (*vbmp3_getLastErrorNo)();

	//VBMP3 ֘A
	int _export pascal (*vbmp3_getVersion)();
	BOOL _export pascal (*vbmp3_setVbmp3Option)(VBMP3_OPTION* pVbmp3Option);
	void _export pascal (*vbmp3_getVbmp3Option)(VBMP3_OPTION* pVbmp3Option);
	BOOL _export pascal (*vbmp3_setDecodeOption)(DEC_OPTION* pDecOption);
	void _export pascal (*vbmp3_getDecodeOption)(DEC_OPTION* pDecOption);
	int _export pascal (*vbmp3_debug)();
	void _export pascal (*vbmp3_setEqualizer)(int* pTable);

	//{n
	BOOL _export pascal (*vbmp3_setStepPitch)(int pitch, int frames);
	int _export pascal (*vbmp3_getStepPitch)();
	BOOL _export pascal (*vbmp3_reload)();
	BOOL _export pascal (*vbmp3_setPitch)(int pitch);
	int _export pascal (*vbmp3_getPitch)();
	BOOL _export pascal (*vbmp3_init)();
	BOOL _export pascal (*vbmp3_free)();
	BOOL _export pascal (*vbmp3_open)(const char* pszName, InputInfo* pInfo);
	BOOL _export pascal (*vbmp3_openW)(const wchar_t* pszNameW, InputInfo* pInfo);
	BOOL _export pascal (*vbmp3_close)();
	int _export pascal (*vbmp3_getState)(int* sec);
	BOOL _export pascal (*vbmp3_play)();
	BOOL _export pascal (*vbmp3_stop)();
	BOOL _export pascal (*vbmp3_pause)();
	BOOL _export pascal (*vbmp3_restart)();
	BOOL _export pascal (*vbmp3_seek)(int pos);
	int _export pascal (*vbmp3_getPlayFlames)();
	BOOL _export pascal (*vbmp3_setPlayFlames)(int flames);
	int _export pascal (*vbmp3_getPlaySamples)();
	int _export pascal (*vbmp3_getTotalSamples)();
	BOOL _export pascal (*vbmp3_setPlaySamples)(int sample);
	BOOL _export pascal (*vbmp3_setVolume)(int left, int right);
	BOOL _export pascal (*vbmp3_getVolume)(int* left, int* right);
	void _export pascal (*vbmp3_setFadeIn)(int on);
	void _export pascal (*vbmp3_setFadeOut)(int on);
	void _export pascal (*vbmp3_fadeOut)();

public:
	bool LoadVBMP3DLL(UnicodeString DllPath)
	{
		DllHandle = LoadLibrary(DllPath.c_str());					// Win32 API

		if(DllHandle != NULL)
		{
			// === Win32 API ŃAhX擾 ===
			//R[obN
			vbmp3_callback = (BOOL (__stdcall *)(INPUT_MSG_PROC pProc))GetProcAddress(DllHandle, "vbmp3_callback");
			vbmp3_startCallback = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_startCallback");
			vbmp3_stopCallback = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_stopCallback");

			//{n
			vbmp3_setStepPitch = (BOOL (__stdcall *)(int pitch, int frames))GetProcAddress(DllHandle, "vbmp3_setStepPitch");
			vbmp3_getStepPitch = (int (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_getStepPitch");
			vbmp3_reload = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_reload");
			vbmp3_setPitch = (BOOL (__stdcall *)(int pitch))GetProcAddress(DllHandle, "vbmp3_setPitch");
			vbmp3_getPitch = (int (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_getPitch");
			vbmp3_init = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_init");
			vbmp3_free = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_free");
			vbmp3_open = (BOOL (__stdcall *)(const char* pszName, InputInfo* pInfo))GetProcAddress(DllHandle, "vbmp3_open");
			vbmp3_openW = (BOOL (__stdcall *)(const wchar_t* pszName, InputInfo* pInfo))GetProcAddress(DllHandle, "vbmp3_openW");
			vbmp3_close = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_close");
			vbmp3_getState = (int (__stdcall *)(int* sec))GetProcAddress(DllHandle, "vbmp3_getState");
			vbmp3_play = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_play");
			vbmp3_stop = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_stop");
			vbmp3_pause = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_pause");
			vbmp3_restart = (BOOL (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_restart");
			vbmp3_seek = (BOOL (__stdcall *)(int pos))GetProcAddress(DllHandle, "vbmp3_seek");
			vbmp3_getPlayFlames = (int (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_getPlayFlames");
			vbmp3_setPlayFlames = (BOOL (__stdcall *)(int flames))GetProcAddress(DllHandle, "vbmp3_setPlayFlames");
			vbmp3_getPlaySamples = (int (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_getPlaySamples");
			vbmp3_getTotalSamples = (int (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_getTotalSamples");
			vbmp3_setPlaySamples = (BOOL (__stdcall *)(int sample))GetProcAddress(DllHandle, "vbmp3_setPlaySamples");
			vbmp3_setVolume = (BOOL (__stdcall *)(int left, int right))GetProcAddress(DllHandle, "vbmp3_setVolume");
			vbmp3_getVolume = (BOOL (__stdcall *)(int* left, int* right))GetProcAddress(DllHandle, "vbmp3_getVolume");
			vbmp3_setFadeIn = (void (__stdcall *)(int on))GetProcAddress(DllHandle, "vbmp3_setFadeIn");
			vbmp3_setFadeOut = (void (__stdcall *)(int on))GetProcAddress(DllHandle, "vbmp3_setFadeOut");
			vbmp3_fadeOut = (void (__stdcall *)(void))GetProcAddress(DllHandle, "vbmp3_fadeOut");

			//---------------
			return(true);
		}
		return(false);
	};
}
